package aegis

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeAssetSummary invokes the aegis.DescribeAssetSummary API synchronously
// api document: https://help.aliyun.com/api/aegis/describeassetsummary.html
func (client *Client) DescribeAssetSummary(request *DescribeAssetSummaryRequest) (response *DescribeAssetSummaryResponse, err error) {
	response = CreateDescribeAssetSummaryResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeAssetSummaryWithChan invokes the aegis.DescribeAssetSummary API asynchronously
// api document: https://help.aliyun.com/api/aegis/describeassetsummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAssetSummaryWithChan(request *DescribeAssetSummaryRequest) (<-chan *DescribeAssetSummaryResponse, <-chan error) {
	responseChan := make(chan *DescribeAssetSummaryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeAssetSummary(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeAssetSummaryWithCallback invokes the aegis.DescribeAssetSummary API asynchronously
// api document: https://help.aliyun.com/api/aegis/describeassetsummary.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAssetSummaryWithCallback(request *DescribeAssetSummaryRequest, callback func(response *DescribeAssetSummaryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeAssetSummaryResponse
		var err error
		defer close(result)
		response, err = client.DescribeAssetSummary(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeAssetSummaryRequest is the request struct for api DescribeAssetSummary
type DescribeAssetSummaryRequest struct {
	*requests.RpcRequest
	SourceIp string `position:"Query" name:"SourceIp"`
	Lang     string `position:"Query" name:"Lang"`
}

// DescribeAssetSummaryResponse is the response struct for api DescribeAssetSummary
type DescribeAssetSummaryResponse struct {
	*responses.BaseResponse
	RequestId string  `json:"RequestId" xml:"RequestId"`
	Summary   Summary `json:"Summary" xml:"Summary"`
}

// CreateDescribeAssetSummaryRequest creates a request to invoke DescribeAssetSummary API
func CreateDescribeAssetSummaryRequest() (request *DescribeAssetSummaryRequest) {
	request = &DescribeAssetSummaryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("aegis", "2016-11-11", "DescribeAssetSummary", "vipaegis", "openAPI")
	return
}

// CreateDescribeAssetSummaryResponse creates a response to parse from DescribeAssetSummary response
func CreateDescribeAssetSummaryResponse() (response *DescribeAssetSummaryResponse) {
	response = &DescribeAssetSummaryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
