package aliyuncvc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateDeviceStartupPicture invokes the aliyuncvc.UpdateDeviceStartupPicture API synchronously
func (client *Client) UpdateDeviceStartupPicture(request *UpdateDeviceStartupPictureRequest) (response *UpdateDeviceStartupPictureResponse, err error) {
	response = CreateUpdateDeviceStartupPictureResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateDeviceStartupPictureWithChan invokes the aliyuncvc.UpdateDeviceStartupPicture API asynchronously
func (client *Client) UpdateDeviceStartupPictureWithChan(request *UpdateDeviceStartupPictureRequest) (<-chan *UpdateDeviceStartupPictureResponse, <-chan error) {
	responseChan := make(chan *UpdateDeviceStartupPictureResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateDeviceStartupPicture(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateDeviceStartupPictureWithCallback invokes the aliyuncvc.UpdateDeviceStartupPicture API asynchronously
func (client *Client) UpdateDeviceStartupPictureWithCallback(request *UpdateDeviceStartupPictureRequest, callback func(response *UpdateDeviceStartupPictureResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateDeviceStartupPictureResponse
		var err error
		defer close(result)
		response, err = client.UpdateDeviceStartupPicture(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateDeviceStartupPictureRequest is the request struct for api UpdateDeviceStartupPicture
type UpdateDeviceStartupPictureRequest struct {
	*requests.RpcRequest
	SerialNumber string `position:"Body" name:"SerialNumber"`
	Picture      string `position:"Body" name:"Picture"`
}

// UpdateDeviceStartupPictureResponse is the response struct for api UpdateDeviceStartupPicture
type UpdateDeviceStartupPictureResponse struct {
	*responses.BaseResponse
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	Message   string `json:"Message" xml:"Message"`
	Success   bool   `json:"Success" xml:"Success"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateDeviceStartupPictureRequest creates a request to invoke UpdateDeviceStartupPicture API
func CreateUpdateDeviceStartupPictureRequest() (request *UpdateDeviceStartupPictureRequest) {
	request = &UpdateDeviceStartupPictureRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("aliyuncvc", "2019-10-30", "UpdateDeviceStartupPicture", "aliyuncvc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateDeviceStartupPictureResponse creates a response to parse from UpdateDeviceStartupPicture response
func CreateUpdateDeviceStartupPictureResponse() (response *UpdateDeviceStartupPictureResponse) {
	response = &UpdateDeviceStartupPictureResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
