package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetEstimateFeeInfo invokes the arms.GetEstimateFeeInfo API synchronously
func (client *Client) GetEstimateFeeInfo(request *GetEstimateFeeInfoRequest) (response *GetEstimateFeeInfoResponse, err error) {
	response = CreateGetEstimateFeeInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetEstimateFeeInfoWithChan invokes the arms.GetEstimateFeeInfo API asynchronously
func (client *Client) GetEstimateFeeInfoWithChan(request *GetEstimateFeeInfoRequest) (<-chan *GetEstimateFeeInfoResponse, <-chan error) {
	responseChan := make(chan *GetEstimateFeeInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetEstimateFeeInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetEstimateFeeInfoWithCallback invokes the arms.GetEstimateFeeInfo API asynchronously
func (client *Client) GetEstimateFeeInfoWithCallback(request *GetEstimateFeeInfoRequest, callback func(response *GetEstimateFeeInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetEstimateFeeInfoResponse
		var err error
		defer close(result)
		response, err = client.GetEstimateFeeInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetEstimateFeeInfoRequest is the request struct for api GetEstimateFeeInfo
type GetEstimateFeeInfoRequest struct {
	*requests.RpcRequest
	UsageCn      requests.Integer `position:"Query" name:"UsageCn"`
	UsageFn      requests.Integer `position:"Query" name:"UsageFn"`
	TargetUserId string           `position:"Query" name:"TargetUserId"`
}

// GetEstimateFeeInfoResponse is the response struct for api GetEstimateFeeInfo
type GetEstimateFeeInfoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateGetEstimateFeeInfoRequest creates a request to invoke GetEstimateFeeInfo API
func CreateGetEstimateFeeInfoRequest() (request *GetEstimateFeeInfoRequest) {
	request = &GetEstimateFeeInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "GetEstimateFeeInfo", "arms", "openAPI")
	request.Method = requests.GET
	return
}

// CreateGetEstimateFeeInfoResponse creates a response to parse from GetEstimateFeeInfo response
func CreateGetEstimateFeeInfoResponse() (response *GetEstimateFeeInfoResponse) {
	response = &GetEstimateFeeInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
