package arms4finance

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ARMSQueryDataSet invokes the arms4finance.ARMSQueryDataSet API synchronously
// api document: https://help.aliyun.com/api/arms4finance/armsquerydataset.html
func (client *Client) ARMSQueryDataSet(request *ARMSQueryDataSetRequest) (response *ARMSQueryDataSetResponse, err error) {
	response = CreateARMSQueryDataSetResponse()
	err = client.DoAction(request, response)
	return
}

// ARMSQueryDataSetWithChan invokes the arms4finance.ARMSQueryDataSet API asynchronously
// api document: https://help.aliyun.com/api/arms4finance/armsquerydataset.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ARMSQueryDataSetWithChan(request *ARMSQueryDataSetRequest) (<-chan *ARMSQueryDataSetResponse, <-chan error) {
	responseChan := make(chan *ARMSQueryDataSetResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ARMSQueryDataSet(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ARMSQueryDataSetWithCallback invokes the arms4finance.ARMSQueryDataSet API asynchronously
// api document: https://help.aliyun.com/api/arms4finance/armsquerydataset.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ARMSQueryDataSetWithCallback(request *ARMSQueryDataSetRequest, callback func(response *ARMSQueryDataSetResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ARMSQueryDataSetResponse
		var err error
		defer close(result)
		response, err = client.ARMSQueryDataSet(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ARMSQueryDataSetRequest is the request struct for api ARMSQueryDataSet
type ARMSQueryDataSetRequest struct {
	*requests.RpcRequest
	Measures      *[]string                     `position:"Query" name:"Measures"  type:"Repeated"`
	IntervalInSec requests.Integer              `position:"Query" name:"IntervalInSec"`
	DateStr       string                        `position:"Query" name:"DateStr"`
	IsDrillDown   requests.Boolean              `position:"Query" name:"IsDrillDown"`
	MinTime       requests.Integer              `position:"Query" name:"MinTime"`
	DatasetId     requests.Integer              `position:"Query" name:"DatasetId"`
	MaxTime       requests.Integer              `position:"Query" name:"MaxTime"`
	Dimensions    *[]ARMSQueryDataSetDimensions `position:"Query" name:"Dimensions"  type:"Repeated"`
}

// ARMSQueryDataSetDimensions is a repeated param struct in ARMSQueryDataSetRequest
type ARMSQueryDataSetDimensions struct {
	Value string `name:"Value"`
	Key   string `name:"Key"`
}

// ARMSQueryDataSetResponse is the response struct for api ARMSQueryDataSet
type ARMSQueryDataSetResponse struct {
	*responses.BaseResponse
	Data string `json:"Data" xml:"Data"`
}

// CreateARMSQueryDataSetRequest creates a request to invoke ARMSQueryDataSet API
func CreateARMSQueryDataSetRequest() (request *ARMSQueryDataSetRequest) {
	request = &ARMSQueryDataSetRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS4FINANCE", "2017-11-30", "ARMSQueryDataSet", "arms4finance", "openAPI")
	return
}

// CreateARMSQueryDataSetResponse creates a response to parse from ARMSQueryDataSet response
func CreateARMSQueryDataSetResponse() (response *ARMSQueryDataSetResponse) {
	response = &ARMSQueryDataSetResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
