package baas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeFabricConsortiumSpecs invokes the baas.DescribeFabricConsortiumSpecs API synchronously
// api document: https://help.aliyun.com/api/baas/describefabricconsortiumspecs.html
func (client *Client) DescribeFabricConsortiumSpecs(request *DescribeFabricConsortiumSpecsRequest) (response *DescribeFabricConsortiumSpecsResponse, err error) {
	response = CreateDescribeFabricConsortiumSpecsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeFabricConsortiumSpecsWithChan invokes the baas.DescribeFabricConsortiumSpecs API asynchronously
// api document: https://help.aliyun.com/api/baas/describefabricconsortiumspecs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFabricConsortiumSpecsWithChan(request *DescribeFabricConsortiumSpecsRequest) (<-chan *DescribeFabricConsortiumSpecsResponse, <-chan error) {
	responseChan := make(chan *DescribeFabricConsortiumSpecsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeFabricConsortiumSpecs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeFabricConsortiumSpecsWithCallback invokes the baas.DescribeFabricConsortiumSpecs API asynchronously
// api document: https://help.aliyun.com/api/baas/describefabricconsortiumspecs.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeFabricConsortiumSpecsWithCallback(request *DescribeFabricConsortiumSpecsRequest, callback func(response *DescribeFabricConsortiumSpecsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeFabricConsortiumSpecsResponse
		var err error
		defer close(result)
		response, err = client.DescribeFabricConsortiumSpecs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeFabricConsortiumSpecsRequest is the request struct for api DescribeFabricConsortiumSpecs
type DescribeFabricConsortiumSpecsRequest struct {
	*requests.RpcRequest
}

// DescribeFabricConsortiumSpecsResponse is the response struct for api DescribeFabricConsortiumSpecs
type DescribeFabricConsortiumSpecsResponse struct {
	*responses.BaseResponse
	RequestId string        `json:"RequestId" xml:"RequestId"`
	Success   bool          `json:"Success" xml:"Success"`
	ErrorCode int           `json:"ErrorCode" xml:"ErrorCode"`
	Result    []ClusterSpec `json:"Result" xml:"Result"`
}

// CreateDescribeFabricConsortiumSpecsRequest creates a request to invoke DescribeFabricConsortiumSpecs API
func CreateDescribeFabricConsortiumSpecsRequest() (request *DescribeFabricConsortiumSpecsRequest) {
	request = &DescribeFabricConsortiumSpecsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Baas", "2018-12-21", "DescribeFabricConsortiumSpecs", "baas", "openAPI")
	return
}

// CreateDescribeFabricConsortiumSpecsResponse creates a response to parse from DescribeFabricConsortiumSpecs response
func CreateDescribeFabricConsortiumSpecsResponse() (response *DescribeFabricConsortiumSpecsResponse) {
	response = &DescribeFabricConsortiumSpecsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
