package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DisableTransitRouterRouteTablePropagation invokes the cbn.DisableTransitRouterRouteTablePropagation API synchronously
func (client *Client) DisableTransitRouterRouteTablePropagation(request *DisableTransitRouterRouteTablePropagationRequest) (response *DisableTransitRouterRouteTablePropagationResponse, err error) {
	response = CreateDisableTransitRouterRouteTablePropagationResponse()
	err = client.DoAction(request, response)
	return
}

// DisableTransitRouterRouteTablePropagationWithChan invokes the cbn.DisableTransitRouterRouteTablePropagation API asynchronously
func (client *Client) DisableTransitRouterRouteTablePropagationWithChan(request *DisableTransitRouterRouteTablePropagationRequest) (<-chan *DisableTransitRouterRouteTablePropagationResponse, <-chan error) {
	responseChan := make(chan *DisableTransitRouterRouteTablePropagationResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DisableTransitRouterRouteTablePropagation(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DisableTransitRouterRouteTablePropagationWithCallback invokes the cbn.DisableTransitRouterRouteTablePropagation API asynchronously
func (client *Client) DisableTransitRouterRouteTablePropagationWithCallback(request *DisableTransitRouterRouteTablePropagationRequest, callback func(response *DisableTransitRouterRouteTablePropagationResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DisableTransitRouterRouteTablePropagationResponse
		var err error
		defer close(result)
		response, err = client.DisableTransitRouterRouteTablePropagation(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DisableTransitRouterRouteTablePropagationRequest is the request struct for api DisableTransitRouterRouteTablePropagation
type DisableTransitRouterRouteTablePropagationRequest struct {
	*requests.RpcRequest
	ResourceOwnerId           requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken               string           `position:"Query" name:"ClientToken"`
	TransitRouterRouteTableId string           `position:"Query" name:"TransitRouterRouteTableId"`
	DryRun                    requests.Boolean `position:"Query" name:"DryRun"`
	ResourceOwnerAccount      string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount              string           `position:"Query" name:"OwnerAccount"`
	OwnerId                   requests.Integer `position:"Query" name:"OwnerId"`
	TransitRouterAttachmentId string           `position:"Query" name:"TransitRouterAttachmentId"`
}

// DisableTransitRouterRouteTablePropagationResponse is the response struct for api DisableTransitRouterRouteTablePropagation
type DisableTransitRouterRouteTablePropagationResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDisableTransitRouterRouteTablePropagationRequest creates a request to invoke DisableTransitRouterRouteTablePropagation API
func CreateDisableTransitRouterRouteTablePropagationRequest() (request *DisableTransitRouterRouteTablePropagationRequest) {
	request = &DisableTransitRouterRouteTablePropagationRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DisableTransitRouterRouteTablePropagation", "", "")
	request.Method = requests.POST
	return
}

// CreateDisableTransitRouterRouteTablePropagationResponse creates a response to parse from DisableTransitRouterRouteTablePropagation response
func CreateDisableTransitRouterRouteTablePropagationResponse() (response *DisableTransitRouterRouteTablePropagationResponse) {
	response = &DisableTransitRouterRouteTablePropagationResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
