package cdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateCdnCertificateSigningRequest invokes the cdn.CreateCdnCertificateSigningRequest API synchronously
func (client *Client) CreateCdnCertificateSigningRequest(request *CreateCdnCertificateSigningRequestRequest) (response *CreateCdnCertificateSigningRequestResponse, err error) {
	response = CreateCreateCdnCertificateSigningRequestResponse()
	err = client.DoAction(request, response)
	return
}

// CreateCdnCertificateSigningRequestWithChan invokes the cdn.CreateCdnCertificateSigningRequest API asynchronously
func (client *Client) CreateCdnCertificateSigningRequestWithChan(request *CreateCdnCertificateSigningRequestRequest) (<-chan *CreateCdnCertificateSigningRequestResponse, <-chan error) {
	responseChan := make(chan *CreateCdnCertificateSigningRequestResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateCdnCertificateSigningRequest(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateCdnCertificateSigningRequestWithCallback invokes the cdn.CreateCdnCertificateSigningRequest API asynchronously
func (client *Client) CreateCdnCertificateSigningRequestWithCallback(request *CreateCdnCertificateSigningRequestRequest, callback func(response *CreateCdnCertificateSigningRequestResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateCdnCertificateSigningRequestResponse
		var err error
		defer close(result)
		response, err = client.CreateCdnCertificateSigningRequest(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateCdnCertificateSigningRequestRequest is the request struct for api CreateCdnCertificateSigningRequest
type CreateCdnCertificateSigningRequestRequest struct {
	*requests.RpcRequest
	Country          string           `position:"Query" name:"Country"`
	City             string           `position:"Query" name:"City"`
	CommonName       string           `position:"Query" name:"CommonName"`
	State            string           `position:"Query" name:"State"`
	Email            string           `position:"Query" name:"Email"`
	SANs             string           `position:"Query" name:"SANs"`
	OwnerId          requests.Integer `position:"Query" name:"OwnerId"`
	Organization     string           `position:"Query" name:"Organization"`
	OrganizationUnit string           `position:"Query" name:"OrganizationUnit"`
}

// CreateCdnCertificateSigningRequestResponse is the response struct for api CreateCdnCertificateSigningRequest
type CreateCdnCertificateSigningRequestResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	CommonName string `json:"CommonName" xml:"CommonName"`
	Csr        string `json:"Csr" xml:"Csr"`
	PubMd5     string `json:"PubMd5" xml:"PubMd5"`
}

// CreateCreateCdnCertificateSigningRequestRequest creates a request to invoke CreateCdnCertificateSigningRequest API
func CreateCreateCdnCertificateSigningRequestRequest() (request *CreateCdnCertificateSigningRequestRequest) {
	request = &CreateCdnCertificateSigningRequestRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cdn", "2018-05-10", "CreateCdnCertificateSigningRequest", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateCdnCertificateSigningRequestResponse creates a response to parse from CreateCdnCertificateSigningRequest response
func CreateCreateCdnCertificateSigningRequestResponse() (response *CreateCdnCertificateSigningRequestResponse) {
	response = &CreateCdnCertificateSigningRequestResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
