package cdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDomainISPData invokes the cdn.DescribeDomainISPData API synchronously
func (client *Client) DescribeDomainISPData(request *DescribeDomainISPDataRequest) (response *DescribeDomainISPDataResponse, err error) {
	response = CreateDescribeDomainISPDataResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDomainISPDataWithChan invokes the cdn.DescribeDomainISPData API asynchronously
func (client *Client) DescribeDomainISPDataWithChan(request *DescribeDomainISPDataRequest) (<-chan *DescribeDomainISPDataResponse, <-chan error) {
	responseChan := make(chan *DescribeDomainISPDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDomainISPData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDomainISPDataWithCallback invokes the cdn.DescribeDomainISPData API asynchronously
func (client *Client) DescribeDomainISPDataWithCallback(request *DescribeDomainISPDataRequest, callback func(response *DescribeDomainISPDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDomainISPDataResponse
		var err error
		defer close(result)
		response, err = client.DescribeDomainISPData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDomainISPDataRequest is the request struct for api DescribeDomainISPData
type DescribeDomainISPDataRequest struct {
	*requests.RpcRequest
	StartTime  string           `position:"Query" name:"StartTime"`
	DomainName string           `position:"Query" name:"DomainName"`
	EndTime    string           `position:"Query" name:"EndTime"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeDomainISPDataResponse is the response struct for api DescribeDomainISPData
type DescribeDomainISPDataResponse struct {
	*responses.BaseResponse
	RequestId    string                       `json:"RequestId" xml:"RequestId"`
	DomainName   string                       `json:"DomainName" xml:"DomainName"`
	DataInterval string                       `json:"DataInterval" xml:"DataInterval"`
	StartTime    string                       `json:"StartTime" xml:"StartTime"`
	EndTime      string                       `json:"EndTime" xml:"EndTime"`
	Value        ValueInDescribeDomainISPData `json:"Value" xml:"Value"`
}

// CreateDescribeDomainISPDataRequest creates a request to invoke DescribeDomainISPData API
func CreateDescribeDomainISPDataRequest() (request *DescribeDomainISPDataRequest) {
	request = &DescribeDomainISPDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cdn", "2018-05-10", "DescribeDomainISPData", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeDomainISPDataResponse creates a response to parse from DescribeDomainISPData response
func CreateDescribeDomainISPDataResponse() (response *DescribeDomainISPDataResponse) {
	response = &DescribeDomainISPDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
