package cloudapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeApisByApp invokes the cloudapi.DescribeApisByApp API synchronously
// api document: https://help.aliyun.com/api/cloudapi/describeapisbyapp.html
func (client *Client) DescribeApisByApp(request *DescribeApisByAppRequest) (response *DescribeApisByAppResponse, err error) {
	response = CreateDescribeApisByAppResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeApisByAppWithChan invokes the cloudapi.DescribeApisByApp API asynchronously
// api document: https://help.aliyun.com/api/cloudapi/describeapisbyapp.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeApisByAppWithChan(request *DescribeApisByAppRequest) (<-chan *DescribeApisByAppResponse, <-chan error) {
	responseChan := make(chan *DescribeApisByAppResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeApisByApp(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeApisByAppWithCallback invokes the cloudapi.DescribeApisByApp API asynchronously
// api document: https://help.aliyun.com/api/cloudapi/describeapisbyapp.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeApisByAppWithCallback(request *DescribeApisByAppRequest, callback func(response *DescribeApisByAppResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeApisByAppResponse
		var err error
		defer close(result)
		response, err = client.DescribeApisByApp(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeApisByAppRequest is the request struct for api DescribeApisByApp
type DescribeApisByAppRequest struct {
	*requests.RpcRequest
	PageNumber    requests.Integer `position:"Query" name:"PageNumber"`
	SecurityToken string           `position:"Query" name:"SecurityToken"`
	AppId         requests.Integer `position:"Query" name:"AppId"`
	ApiUid        string           `position:"Query" name:"ApiUid"`
	PageSize      requests.Integer `position:"Query" name:"PageSize"`
}

// DescribeApisByAppResponse is the response struct for api DescribeApisByApp
type DescribeApisByAppResponse struct {
	*responses.BaseResponse
	RequestId           string              `json:"RequestId" xml:"RequestId"`
	TotalCount          int                 `json:"TotalCount" xml:"TotalCount"`
	PageSize            int                 `json:"PageSize" xml:"PageSize"`
	PageNumber          int                 `json:"PageNumber" xml:"PageNumber"`
	AppApiRelationInfos AppApiRelationInfos `json:"AppApiRelationInfos" xml:"AppApiRelationInfos"`
}

// CreateDescribeApisByAppRequest creates a request to invoke DescribeApisByApp API
func CreateDescribeApisByAppRequest() (request *DescribeApisByAppRequest) {
	request = &DescribeApisByAppRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudAPI", "2016-07-14", "DescribeApisByApp", "apigateway", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeApisByAppResponse creates a response to parse from DescribeApisByApp response
func CreateDescribeApisByAppResponse() (response *DescribeApisByAppResponse) {
	response = &DescribeApisByAppResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
