package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CancelContactFlowVersionModification invokes the cloudcallcenter.CancelContactFlowVersionModification API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/cancelcontactflowversionmodification.html
func (client *Client) CancelContactFlowVersionModification(request *CancelContactFlowVersionModificationRequest) (response *CancelContactFlowVersionModificationResponse, err error) {
	response = CreateCancelContactFlowVersionModificationResponse()
	err = client.DoAction(request, response)
	return
}

// CancelContactFlowVersionModificationWithChan invokes the cloudcallcenter.CancelContactFlowVersionModification API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/cancelcontactflowversionmodification.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CancelContactFlowVersionModificationWithChan(request *CancelContactFlowVersionModificationRequest) (<-chan *CancelContactFlowVersionModificationResponse, <-chan error) {
	responseChan := make(chan *CancelContactFlowVersionModificationResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CancelContactFlowVersionModification(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CancelContactFlowVersionModificationWithCallback invokes the cloudcallcenter.CancelContactFlowVersionModification API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/cancelcontactflowversionmodification.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) CancelContactFlowVersionModificationWithCallback(request *CancelContactFlowVersionModificationRequest, callback func(response *CancelContactFlowVersionModificationResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CancelContactFlowVersionModificationResponse
		var err error
		defer close(result)
		response, err = client.CancelContactFlowVersionModification(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CancelContactFlowVersionModificationRequest is the request struct for api CancelContactFlowVersionModification
type CancelContactFlowVersionModificationRequest struct {
	*requests.RpcRequest
	InstanceId           string `position:"Query" name:"InstanceId"`
	ContactFlowVersionId string `position:"Query" name:"ContactFlowVersionId"`
}

// CancelContactFlowVersionModificationResponse is the response struct for api CancelContactFlowVersionModification
type CancelContactFlowVersionModificationResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Success        bool   `json:"Success" xml:"Success"`
	Code           string `json:"Code" xml:"Code"`
	Message        string `json:"Message" xml:"Message"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
}

// CreateCancelContactFlowVersionModificationRequest creates a request to invoke CancelContactFlowVersionModification API
func CreateCancelContactFlowVersionModificationRequest() (request *CancelContactFlowVersionModificationRequest) {
	request = &CancelContactFlowVersionModificationRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "CancelContactFlowVersionModification", "", "")
	request.Method = requests.POST
	return
}

// CreateCancelContactFlowVersionModificationResponse creates a response to parse from CancelContactFlowVersionModification response
func CreateCancelContactFlowVersionModificationResponse() (response *CancelContactFlowVersionModificationResponse) {
	response = &CancelContactFlowVersionModificationResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
