package cloudcallcenter

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// PreCreateMedia invokes the cloudcallcenter.PreCreateMedia API synchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/precreatemedia.html
func (client *Client) PreCreateMedia(request *PreCreateMediaRequest) (response *PreCreateMediaResponse, err error) {
	response = CreatePreCreateMediaResponse()
	err = client.DoAction(request, response)
	return
}

// PreCreateMediaWithChan invokes the cloudcallcenter.PreCreateMedia API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/precreatemedia.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCreateMediaWithChan(request *PreCreateMediaRequest) (<-chan *PreCreateMediaResponse, <-chan error) {
	responseChan := make(chan *PreCreateMediaResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.PreCreateMedia(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// PreCreateMediaWithCallback invokes the cloudcallcenter.PreCreateMedia API asynchronously
// api document: https://help.aliyun.com/api/cloudcallcenter/precreatemedia.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) PreCreateMediaWithCallback(request *PreCreateMediaRequest, callback func(response *PreCreateMediaResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *PreCreateMediaResponse
		var err error
		defer close(result)
		response, err = client.PreCreateMedia(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// PreCreateMediaRequest is the request struct for api PreCreateMedia
type PreCreateMediaRequest struct {
	*requests.RpcRequest
	InstanceId  string `position:"Query" name:"InstanceId"`
	FileName    string `position:"Query" name:"FileName"`
	Name        string `position:"Query" name:"Name"`
	Description string `position:"Query" name:"Description"`
	Type        string `position:"Query" name:"Type"`
	Content     string `position:"Query" name:"Content"`
}

// PreCreateMediaResponse is the response struct for api PreCreateMedia
type PreCreateMediaResponse struct {
	*responses.BaseResponse
	RequestId           string              `json:"RequestId" xml:"RequestId"`
	Success             bool                `json:"Success" xml:"Success"`
	Code                string              `json:"Code" xml:"Code"`
	Message             string              `json:"Message" xml:"Message"`
	HttpStatusCode      int                 `json:"HttpStatusCode" xml:"HttpStatusCode"`
	PreCreateMediaParam PreCreateMediaParam `json:"PreCreateMediaParam" xml:"PreCreateMediaParam"`
}

// CreatePreCreateMediaRequest creates a request to invoke PreCreateMedia API
func CreatePreCreateMediaRequest() (request *PreCreateMediaRequest) {
	request = &PreCreateMediaRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CloudCallCenter", "2017-07-05", "PreCreateMedia", "", "")
	request.Method = requests.POST
	return
}

// CreatePreCreateMediaResponse creates a response to parse from PreCreateMedia response
func CreatePreCreateMediaResponse() (response *PreCreateMediaResponse) {
	response = &PreCreateMediaResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
