package cloudesl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeStoreConfig invokes the cloudesl.DescribeStoreConfig API synchronously
func (client *Client) DescribeStoreConfig(request *DescribeStoreConfigRequest) (response *DescribeStoreConfigResponse, err error) {
	response = CreateDescribeStoreConfigResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeStoreConfigWithChan invokes the cloudesl.DescribeStoreConfig API asynchronously
func (client *Client) DescribeStoreConfigWithChan(request *DescribeStoreConfigRequest) (<-chan *DescribeStoreConfigResponse, <-chan error) {
	responseChan := make(chan *DescribeStoreConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeStoreConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeStoreConfigWithCallback invokes the cloudesl.DescribeStoreConfig API asynchronously
func (client *Client) DescribeStoreConfigWithCallback(request *DescribeStoreConfigRequest, callback func(response *DescribeStoreConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeStoreConfigResponse
		var err error
		defer close(result)
		response, err = client.DescribeStoreConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeStoreConfigRequest is the request struct for api DescribeStoreConfig
type DescribeStoreConfigRequest struct {
	*requests.RpcRequest
	ExtraParams string `position:"Body" name:"ExtraParams"`
	StoreId     string `position:"Body" name:"StoreId"`
}

// DescribeStoreConfigResponse is the response struct for api DescribeStoreConfig
type DescribeStoreConfigResponse struct {
	*responses.BaseResponse
	ErrorMessage    string          `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode       string          `json:"ErrorCode" xml:"ErrorCode"`
	Message         string          `json:"Message" xml:"Message"`
	DynamicCode     string          `json:"DynamicCode" xml:"DynamicCode"`
	Code            string          `json:"Code" xml:"Code"`
	DynamicMessage  string          `json:"DynamicMessage" xml:"DynamicMessage"`
	RequestId       string          `json:"RequestId" xml:"RequestId"`
	Success         bool            `json:"Success" xml:"Success"`
	StoreConfigInfo StoreConfigInfo `json:"StoreConfigInfo" xml:"StoreConfigInfo"`
}

// CreateDescribeStoreConfigRequest creates a request to invoke DescribeStoreConfig API
func CreateDescribeStoreConfigRequest() (request *DescribeStoreConfigRequest) {
	request = &DescribeStoreConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudesl", "2020-02-01", "DescribeStoreConfig", "cloudesl", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeStoreConfigResponse creates a response to parse from DescribeStoreConfig response
func CreateDescribeStoreConfigResponse() (response *DescribeStoreConfigResponse) {
	response = &DescribeStoreConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
