package cloudwf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ReportZoneRealtime invokes the cloudwf.ReportZoneRealtime API synchronously
// api document: https://help.aliyun.com/api/cloudwf/reportzonerealtime.html
func (client *Client) ReportZoneRealtime(request *ReportZoneRealtimeRequest) (response *ReportZoneRealtimeResponse, err error) {
	response = CreateReportZoneRealtimeResponse()
	err = client.DoAction(request, response)
	return
}

// ReportZoneRealtimeWithChan invokes the cloudwf.ReportZoneRealtime API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/reportzonerealtime.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ReportZoneRealtimeWithChan(request *ReportZoneRealtimeRequest) (<-chan *ReportZoneRealtimeResponse, <-chan error) {
	responseChan := make(chan *ReportZoneRealtimeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ReportZoneRealtime(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ReportZoneRealtimeWithCallback invokes the cloudwf.ReportZoneRealtime API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/reportzonerealtime.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ReportZoneRealtimeWithCallback(request *ReportZoneRealtimeRequest, callback func(response *ReportZoneRealtimeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ReportZoneRealtimeResponse
		var err error
		defer close(result)
		response, err = client.ReportZoneRealtime(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ReportZoneRealtimeRequest is the request struct for api ReportZoneRealtime
type ReportZoneRealtimeRequest struct {
	*requests.RpcRequest
	Agsid requests.Integer `position:"Query" name:"Agsid"`
}

// ReportZoneRealtimeResponse is the response struct for api ReportZoneRealtime
type ReportZoneRealtimeResponse struct {
	*responses.BaseResponse
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg  string `json:"ErrorMsg" xml:"ErrorMsg"`
}

// CreateReportZoneRealtimeRequest creates a request to invoke ReportZoneRealtime API
func CreateReportZoneRealtimeRequest() (request *ReportZoneRealtimeRequest) {
	request = &ReportZoneRealtimeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudwf", "2017-03-28", "ReportZoneRealtime", "cloudwf", "openAPI")
	return
}

// CreateReportZoneRealtimeResponse creates a response to parse from ReportZoneRealtime response
func CreateReportZoneRealtimeResponse() (response *ReportZoneRealtimeResponse) {
	response = &ReportZoneRealtimeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
