package cloudwf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ShopGroupDelete invokes the cloudwf.ShopGroupDelete API synchronously
// api document: https://help.aliyun.com/api/cloudwf/shopgroupdelete.html
func (client *Client) ShopGroupDelete(request *ShopGroupDeleteRequest) (response *ShopGroupDeleteResponse, err error) {
	response = CreateShopGroupDeleteResponse()
	err = client.DoAction(request, response)
	return
}

// ShopGroupDeleteWithChan invokes the cloudwf.ShopGroupDelete API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/shopgroupdelete.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ShopGroupDeleteWithChan(request *ShopGroupDeleteRequest) (<-chan *ShopGroupDeleteResponse, <-chan error) {
	responseChan := make(chan *ShopGroupDeleteResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ShopGroupDelete(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ShopGroupDeleteWithCallback invokes the cloudwf.ShopGroupDelete API asynchronously
// api document: https://help.aliyun.com/api/cloudwf/shopgroupdelete.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ShopGroupDeleteWithCallback(request *ShopGroupDeleteRequest, callback func(response *ShopGroupDeleteResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ShopGroupDeleteResponse
		var err error
		defer close(result)
		response, err = client.ShopGroupDelete(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ShopGroupDeleteRequest is the request struct for api ShopGroupDelete
type ShopGroupDeleteRequest struct {
	*requests.RpcRequest
	Gid requests.Integer `position:"Query" name:"Gid"`
}

// ShopGroupDeleteResponse is the response struct for api ShopGroupDelete
type ShopGroupDeleteResponse struct {
	*responses.BaseResponse
	Success   bool   `json:"Success" xml:"Success"`
	Data      string `json:"Data" xml:"Data"`
	ErrorCode int    `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg  string `json:"ErrorMsg" xml:"ErrorMsg"`
}

// CreateShopGroupDeleteRequest creates a request to invoke ShopGroupDelete API
func CreateShopGroupDeleteRequest() (request *ShopGroupDeleteRequest) {
	request = &ShopGroupDeleteRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("cloudwf", "2017-03-28", "ShopGroupDelete", "cloudwf", "openAPI")
	return
}

// CreateShopGroupDeleteResponse creates a response to parse from ShopGroupDelete response
func CreateShopGroupDeleteResponse() (response *ShopGroupDeleteResponse) {
	response = &ShopGroupDeleteResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
