package codeup

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetMergeRequestApproveStatus invokes the codeup.GetMergeRequestApproveStatus API synchronously
func (client *Client) GetMergeRequestApproveStatus(request *GetMergeRequestApproveStatusRequest) (response *GetMergeRequestApproveStatusResponse, err error) {
	response = CreateGetMergeRequestApproveStatusResponse()
	err = client.DoAction(request, response)
	return
}

// GetMergeRequestApproveStatusWithChan invokes the codeup.GetMergeRequestApproveStatus API asynchronously
func (client *Client) GetMergeRequestApproveStatusWithChan(request *GetMergeRequestApproveStatusRequest) (<-chan *GetMergeRequestApproveStatusResponse, <-chan error) {
	responseChan := make(chan *GetMergeRequestApproveStatusResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetMergeRequestApproveStatus(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetMergeRequestApproveStatusWithCallback invokes the codeup.GetMergeRequestApproveStatus API asynchronously
func (client *Client) GetMergeRequestApproveStatusWithCallback(request *GetMergeRequestApproveStatusRequest, callback func(response *GetMergeRequestApproveStatusResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetMergeRequestApproveStatusResponse
		var err error
		defer close(result)
		response, err = client.GetMergeRequestApproveStatus(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetMergeRequestApproveStatusRequest is the request struct for api GetMergeRequestApproveStatus
type GetMergeRequestApproveStatusRequest struct {
	*requests.RoaRequest
	OrganizationId string           `position:"Query" name:"OrganizationId"`
	MergeRequestId requests.Integer `position:"Path" name:"MergeRequestId"`
	AccessToken    string           `position:"Query" name:"AccessToken"`
	ProjectId      requests.Integer `position:"Path" name:"ProjectId"`
}

// GetMergeRequestApproveStatusResponse is the response struct for api GetMergeRequestApproveStatus
type GetMergeRequestApproveStatusResponse struct {
	*responses.BaseResponse
	ErrorCode    string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	RequestId    string `json:"RequestId" xml:"RequestId"`
	Success      bool   `json:"Success" xml:"Success"`
	Result       Result `json:"Result" xml:"Result"`
}

// CreateGetMergeRequestApproveStatusRequest creates a request to invoke GetMergeRequestApproveStatus API
func CreateGetMergeRequestApproveStatusRequest() (request *GetMergeRequestApproveStatusRequest) {
	request = &GetMergeRequestApproveStatusRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("codeup", "2020-04-14", "GetMergeRequestApproveStatus", "/api/v4/projects/[ProjectId]/merge_request/[MergeRequestId]/approve_status", "", "")
	request.Method = requests.GET
	return
}

// CreateGetMergeRequestApproveStatusResponse creates a response to parse from GetMergeRequestApproveStatus response
func CreateGetMergeRequestApproveStatusResponse() (response *GetMergeRequestApproveStatusResponse) {
	response = &GetMergeRequestApproveStatusResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
