package codeup

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListRepositoryCommitDiff invokes the codeup.ListRepositoryCommitDiff API synchronously
func (client *Client) ListRepositoryCommitDiff(request *ListRepositoryCommitDiffRequest) (response *ListRepositoryCommitDiffResponse, err error) {
	response = CreateListRepositoryCommitDiffResponse()
	err = client.DoAction(request, response)
	return
}

// ListRepositoryCommitDiffWithChan invokes the codeup.ListRepositoryCommitDiff API asynchronously
func (client *Client) ListRepositoryCommitDiffWithChan(request *ListRepositoryCommitDiffRequest) (<-chan *ListRepositoryCommitDiffResponse, <-chan error) {
	responseChan := make(chan *ListRepositoryCommitDiffResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListRepositoryCommitDiff(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListRepositoryCommitDiffWithCallback invokes the codeup.ListRepositoryCommitDiff API asynchronously
func (client *Client) ListRepositoryCommitDiffWithCallback(request *ListRepositoryCommitDiffRequest, callback func(response *ListRepositoryCommitDiffResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListRepositoryCommitDiffResponse
		var err error
		defer close(result)
		response, err = client.ListRepositoryCommitDiff(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListRepositoryCommitDiffRequest is the request struct for api ListRepositoryCommitDiff
type ListRepositoryCommitDiffRequest struct {
	*requests.RoaRequest
	OrganizationId string           `position:"Query" name:"OrganizationId"`
	AccessToken    string           `position:"Query" name:"AccessToken"`
	ContextLine    requests.Integer `position:"Query" name:"ContextLine"`
	ProjectId      requests.Integer `position:"Path" name:"ProjectId"`
	Sha            string           `position:"Path" name:"Sha"`
}

// ListRepositoryCommitDiffResponse is the response struct for api ListRepositoryCommitDiff
type ListRepositoryCommitDiffResponse struct {
	*responses.BaseResponse
	ErrorCode    string       `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage string       `json:"ErrorMessage" xml:"ErrorMessage"`
	RequestId    string       `json:"RequestId" xml:"RequestId"`
	Success      bool         `json:"Success" xml:"Success"`
	Result       []ResultItem `json:"Result" xml:"Result"`
}

// CreateListRepositoryCommitDiffRequest creates a request to invoke ListRepositoryCommitDiff API
func CreateListRepositoryCommitDiffRequest() (request *ListRepositoryCommitDiffRequest) {
	request = &ListRepositoryCommitDiffRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("codeup", "2020-04-14", "ListRepositoryCommitDiff", "/api/v3/projects/[ProjectId]/repository/commits/[Sha]/diff", "", "")
	request.Method = requests.GET
	return
}

// CreateListRepositoryCommitDiffResponse creates a response to parse from ListRepositoryCommitDiff response
func CreateListRepositoryCommitDiffResponse() (response *ListRepositoryCommitDiffResponse) {
	response = &ListRepositoryCommitDiffResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
