package config

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetAggregateAccountComplianceByPack invokes the config.GetAggregateAccountComplianceByPack API synchronously
func (client *Client) GetAggregateAccountComplianceByPack(request *GetAggregateAccountComplianceByPackRequest) (response *GetAggregateAccountComplianceByPackResponse, err error) {
	response = CreateGetAggregateAccountComplianceByPackResponse()
	err = client.DoAction(request, response)
	return
}

// GetAggregateAccountComplianceByPackWithChan invokes the config.GetAggregateAccountComplianceByPack API asynchronously
func (client *Client) GetAggregateAccountComplianceByPackWithChan(request *GetAggregateAccountComplianceByPackRequest) (<-chan *GetAggregateAccountComplianceByPackResponse, <-chan error) {
	responseChan := make(chan *GetAggregateAccountComplianceByPackResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetAggregateAccountComplianceByPack(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetAggregateAccountComplianceByPackWithCallback invokes the config.GetAggregateAccountComplianceByPack API asynchronously
func (client *Client) GetAggregateAccountComplianceByPackWithCallback(request *GetAggregateAccountComplianceByPackRequest, callback func(response *GetAggregateAccountComplianceByPackResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetAggregateAccountComplianceByPackResponse
		var err error
		defer close(result)
		response, err = client.GetAggregateAccountComplianceByPack(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetAggregateAccountComplianceByPackRequest is the request struct for api GetAggregateAccountComplianceByPack
type GetAggregateAccountComplianceByPackRequest struct {
	*requests.RpcRequest
	AggregatorId     string `position:"Query" name:"AggregatorId"`
	CompliancePackId string `position:"Query" name:"CompliancePackId"`
}

// GetAggregateAccountComplianceByPackResponse is the response struct for api GetAggregateAccountComplianceByPack
type GetAggregateAccountComplianceByPackResponse struct {
	*responses.BaseResponse
	RequestId               string                  `json:"RequestId" xml:"RequestId"`
	AccountComplianceResult AccountComplianceResult `json:"AccountComplianceResult" xml:"AccountComplianceResult"`
}

// CreateGetAggregateAccountComplianceByPackRequest creates a request to invoke GetAggregateAccountComplianceByPack API
func CreateGetAggregateAccountComplianceByPackRequest() (request *GetAggregateAccountComplianceByPackRequest) {
	request = &GetAggregateAccountComplianceByPackRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Config", "2020-09-07", "GetAggregateAccountComplianceByPack", "", "")
	request.Method = requests.GET
	return
}

// CreateGetAggregateAccountComplianceByPackResponse creates a response to parse from GetAggregateAccountComplianceByPack response
func CreateGetAggregateAccountComplianceByPackResponse() (response *GetAggregateAccountComplianceByPackResponse) {
	response = &GetAggregateAccountComplianceByPackResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
