package cs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeClusterAddonsVersion invokes the cs.DescribeClusterAddonsVersion API synchronously
func (client *Client) DescribeClusterAddonsVersion(request *DescribeClusterAddonsVersionRequest) (response *DescribeClusterAddonsVersionResponse, err error) {
	response = CreateDescribeClusterAddonsVersionResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeClusterAddonsVersionWithChan invokes the cs.DescribeClusterAddonsVersion API asynchronously
func (client *Client) DescribeClusterAddonsVersionWithChan(request *DescribeClusterAddonsVersionRequest) (<-chan *DescribeClusterAddonsVersionResponse, <-chan error) {
	responseChan := make(chan *DescribeClusterAddonsVersionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeClusterAddonsVersion(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeClusterAddonsVersionWithCallback invokes the cs.DescribeClusterAddonsVersion API asynchronously
func (client *Client) DescribeClusterAddonsVersionWithCallback(request *DescribeClusterAddonsVersionRequest, callback func(response *DescribeClusterAddonsVersionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeClusterAddonsVersionResponse
		var err error
		defer close(result)
		response, err = client.DescribeClusterAddonsVersion(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeClusterAddonsVersionRequest is the request struct for api DescribeClusterAddonsVersion
type DescribeClusterAddonsVersionRequest struct {
	*requests.RoaRequest
	ClusterId string `position:"Path" name:"ClusterId"`
}

// DescribeClusterAddonsVersionResponse is the response struct for api DescribeClusterAddonsVersion
type DescribeClusterAddonsVersionResponse struct {
	*responses.BaseResponse
}

// CreateDescribeClusterAddonsVersionRequest creates a request to invoke DescribeClusterAddonsVersion API
func CreateDescribeClusterAddonsVersionRequest() (request *DescribeClusterAddonsVersionRequest) {
	request = &DescribeClusterAddonsVersionRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("CS", "2015-12-15", "DescribeClusterAddonsVersion", "/clusters/[ClusterId]/components/version", "", "")
	request.Method = requests.GET
	return
}

// CreateDescribeClusterAddonsVersionResponse creates a response to parse from DescribeClusterAddonsVersion response
func CreateDescribeClusterAddonsVersionResponse() (response *DescribeClusterAddonsVersionResponse) {
	response = &DescribeClusterAddonsVersionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
