package das

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateAdamBenchTask invokes the das.CreateAdamBenchTask API synchronously
func (client *Client) CreateAdamBenchTask(request *CreateAdamBenchTaskRequest) (response *CreateAdamBenchTaskResponse, err error) {
	response = CreateCreateAdamBenchTaskResponse()
	err = client.DoAction(request, response)
	return
}

// CreateAdamBenchTaskWithChan invokes the das.CreateAdamBenchTask API asynchronously
func (client *Client) CreateAdamBenchTaskWithChan(request *CreateAdamBenchTaskRequest) (<-chan *CreateAdamBenchTaskResponse, <-chan error) {
	responseChan := make(chan *CreateAdamBenchTaskResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateAdamBenchTask(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateAdamBenchTaskWithCallback invokes the das.CreateAdamBenchTask API asynchronously
func (client *Client) CreateAdamBenchTaskWithCallback(request *CreateAdamBenchTaskRequest, callback func(response *CreateAdamBenchTaskResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateAdamBenchTaskResponse
		var err error
		defer close(result)
		response, err = client.CreateAdamBenchTask(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateAdamBenchTaskRequest is the request struct for api CreateAdamBenchTask
type CreateAdamBenchTaskRequest struct {
	*requests.RpcRequest
	SrcEngine        string           `position:"Query" name:"SrcEngine"`
	Description      string           `position:"Query" name:"Description"`
	RequestStartTime requests.Integer `position:"Query" name:"RequestStartTime"`
	DstSuperPassword string           `position:"Query" name:"DstSuperPassword"`
	DstSuperAccount  string           `position:"Query" name:"DstSuperAccount"`
	Rate             requests.Integer `position:"Query" name:"Rate"`
	DstInstanceId    string           `position:"Query" name:"DstInstanceId"`
	RequestDuration  requests.Integer `position:"Query" name:"RequestDuration"`
	SrcMeanQps       string           `position:"Query" name:"SrcMeanQps"`
	SrcMaxQps        string           `position:"Query" name:"SrcMaxQps"`
	SrcEngineVersion string           `position:"Query" name:"SrcEngineVersion"`
	SrcSqlOssAddr    string           `position:"Query" name:"SrcSqlOssAddr"`
}

// CreateAdamBenchTaskResponse is the response struct for api CreateAdamBenchTask
type CreateAdamBenchTaskResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      string `json:"Data" xml:"Data"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   string `json:"Success" xml:"Success"`
}

// CreateCreateAdamBenchTaskRequest creates a request to invoke CreateAdamBenchTask API
func CreateCreateAdamBenchTaskRequest() (request *CreateAdamBenchTaskRequest) {
	request = &CreateAdamBenchTaskRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("DAS", "2020-01-16", "CreateAdamBenchTask", "das", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateAdamBenchTaskResponse creates a response to parse from CreateAdamBenchTask response
func CreateCreateAdamBenchTaskResponse() (response *CreateAdamBenchTaskResponse) {
	response = &CreateAdamBenchTaskResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
