package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateTableTheme invokes the dataworks_public.CreateTableTheme API synchronously
func (client *Client) CreateTableTheme(request *CreateTableThemeRequest) (response *CreateTableThemeResponse, err error) {
	response = CreateCreateTableThemeResponse()
	err = client.DoAction(request, response)
	return
}

// CreateTableThemeWithChan invokes the dataworks_public.CreateTableTheme API asynchronously
func (client *Client) CreateTableThemeWithChan(request *CreateTableThemeRequest) (<-chan *CreateTableThemeResponse, <-chan error) {
	responseChan := make(chan *CreateTableThemeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateTableTheme(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateTableThemeWithCallback invokes the dataworks_public.CreateTableTheme API asynchronously
func (client *Client) CreateTableThemeWithCallback(request *CreateTableThemeRequest, callback func(response *CreateTableThemeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateTableThemeResponse
		var err error
		defer close(result)
		response, err = client.CreateTableTheme(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateTableThemeRequest is the request struct for api CreateTableTheme
type CreateTableThemeRequest struct {
	*requests.RpcRequest
	Level     requests.Integer `position:"Query" name:"Level"`
	Name      string           `position:"Query" name:"Name"`
	ProjectId requests.Integer `position:"Query" name:"ProjectId"`
	ParentId  requests.Integer `position:"Query" name:"ParentId"`
}

// CreateTableThemeResponse is the response struct for api CreateTableTheme
type CreateTableThemeResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Success        bool   `json:"Success" xml:"Success"`
	ThemeId        int64  `json:"ThemeId" xml:"ThemeId"`
}

// CreateCreateTableThemeRequest creates a request to invoke CreateTableTheme API
func CreateCreateTableThemeRequest() (request *CreateTableThemeRequest) {
	request = &CreateTableThemeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "CreateTableTheme", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateTableThemeResponse creates a response to parse from CreateTableTheme response
func CreateCreateTableThemeResponse() (response *CreateTableThemeResponse) {
	response = &CreateTableThemeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
