package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListDags invokes the dataworks_public.ListDags API synchronously
func (client *Client) ListDags(request *ListDagsRequest) (response *ListDagsResponse, err error) {
	response = CreateListDagsResponse()
	err = client.DoAction(request, response)
	return
}

// ListDagsWithChan invokes the dataworks_public.ListDags API asynchronously
func (client *Client) ListDagsWithChan(request *ListDagsRequest) (<-chan *ListDagsResponse, <-chan error) {
	responseChan := make(chan *ListDagsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListDags(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListDagsWithCallback invokes the dataworks_public.ListDags API asynchronously
func (client *Client) ListDagsWithCallback(request *ListDagsRequest, callback func(response *ListDagsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListDagsResponse
		var err error
		defer close(result)
		response, err = client.ListDags(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListDagsRequest is the request struct for api ListDags
type ListDagsRequest struct {
	*requests.RpcRequest
	ProjectEnv string           `position:"Body" name:"ProjectEnv"`
	OpSeq      requests.Integer `position:"Body" name:"OpSeq"`
}

// ListDagsResponse is the response struct for api ListDags
type ListDagsResponse struct {
	*responses.BaseResponse
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Success        bool   `json:"Success" xml:"Success"`
	Data           Data   `json:"Data" xml:"Data"`
}

// CreateListDagsRequest creates a request to invoke ListDags API
func CreateListDagsRequest() (request *ListDagsRequest) {
	request = &ListDagsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "ListDags", "", "")
	request.Method = requests.POST
	return
}

// CreateListDagsResponse creates a response to parse from ListDags response
func CreateListDagsResponse() (response *ListDagsResponse) {
	response = &ListDagsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
