package dbs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CloseDLAService invokes the dbs.CloseDLAService API synchronously
func (client *Client) CloseDLAService(request *CloseDLAServiceRequest) (response *CloseDLAServiceResponse, err error) {
	response = CreateCloseDLAServiceResponse()
	err = client.DoAction(request, response)
	return
}

// CloseDLAServiceWithChan invokes the dbs.CloseDLAService API asynchronously
func (client *Client) CloseDLAServiceWithChan(request *CloseDLAServiceRequest) (<-chan *CloseDLAServiceResponse, <-chan error) {
	responseChan := make(chan *CloseDLAServiceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CloseDLAService(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CloseDLAServiceWithCallback invokes the dbs.CloseDLAService API asynchronously
func (client *Client) CloseDLAServiceWithCallback(request *CloseDLAServiceRequest, callback func(response *CloseDLAServiceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CloseDLAServiceResponse
		var err error
		defer close(result)
		response, err = client.CloseDLAService(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CloseDLAServiceRequest is the request struct for api CloseDLAService
type CloseDLAServiceRequest struct {
	*requests.RpcRequest
	ClientToken  string `position:"Query" name:"ClientToken"`
	BackupPlanId string `position:"Query" name:"BackupPlanId"`
	OwnerId      string `position:"Query" name:"OwnerId"`
}

// CloseDLAServiceResponse is the response struct for api CloseDLAService
type CloseDLAServiceResponse struct {
	*responses.BaseResponse
	Success        bool   `json:"Success" xml:"Success"`
	ErrCode        string `json:"ErrCode" xml:"ErrCode"`
	ErrMessage     string `json:"ErrMessage" xml:"ErrMessage"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
}

// CreateCloseDLAServiceRequest creates a request to invoke CloseDLAService API
func CreateCloseDLAServiceRequest() (request *CloseDLAServiceRequest) {
	request = &CloseDLAServiceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dbs", "2019-03-06", "CloseDLAService", "cbs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCloseDLAServiceResponse creates a response to parse from CloseDLAService response
func CreateCloseDLAServiceResponse() (response *CloseDLAServiceResponse) {
	response = &CloseDLAServiceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
