package dbs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeBackupPlanBilling invokes the dbs.DescribeBackupPlanBilling API synchronously
func (client *Client) DescribeBackupPlanBilling(request *DescribeBackupPlanBillingRequest) (response *DescribeBackupPlanBillingResponse, err error) {
	response = CreateDescribeBackupPlanBillingResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeBackupPlanBillingWithChan invokes the dbs.DescribeBackupPlanBilling API asynchronously
func (client *Client) DescribeBackupPlanBillingWithChan(request *DescribeBackupPlanBillingRequest) (<-chan *DescribeBackupPlanBillingResponse, <-chan error) {
	responseChan := make(chan *DescribeBackupPlanBillingResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeBackupPlanBilling(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeBackupPlanBillingWithCallback invokes the dbs.DescribeBackupPlanBilling API asynchronously
func (client *Client) DescribeBackupPlanBillingWithCallback(request *DescribeBackupPlanBillingRequest, callback func(response *DescribeBackupPlanBillingResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeBackupPlanBillingResponse
		var err error
		defer close(result)
		response, err = client.DescribeBackupPlanBilling(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeBackupPlanBillingRequest is the request struct for api DescribeBackupPlanBilling
type DescribeBackupPlanBillingRequest struct {
	*requests.RpcRequest
	ClientToken     string           `position:"Query" name:"ClientToken"`
	BackupPlanId    string           `position:"Query" name:"BackupPlanId"`
	OwnerId         string           `position:"Query" name:"OwnerId"`
	ShowStorageType requests.Boolean `position:"Query" name:"ShowStorageType"`
}

// DescribeBackupPlanBillingResponse is the response struct for api DescribeBackupPlanBilling
type DescribeBackupPlanBillingResponse struct {
	*responses.BaseResponse
	Success        bool   `json:"Success" xml:"Success"`
	ErrCode        string `json:"ErrCode" xml:"ErrCode"`
	ErrMessage     string `json:"ErrMessage" xml:"ErrMessage"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	Item           Item   `json:"Item" xml:"Item"`
}

// CreateDescribeBackupPlanBillingRequest creates a request to invoke DescribeBackupPlanBilling API
func CreateDescribeBackupPlanBillingRequest() (request *DescribeBackupPlanBillingRequest) {
	request = &DescribeBackupPlanBillingRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dbs", "2019-03-06", "DescribeBackupPlanBilling", "cbs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeBackupPlanBillingResponse creates a response to parse from DescribeBackupPlanBilling response
func CreateDescribeBackupPlanBillingResponse() (response *DescribeBackupPlanBillingResponse) {
	response = &DescribeBackupPlanBillingResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
