package dbs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EnableBackupLog invokes the dbs.EnableBackupLog API synchronously
func (client *Client) EnableBackupLog(request *EnableBackupLogRequest) (response *EnableBackupLogResponse, err error) {
	response = CreateEnableBackupLogResponse()
	err = client.DoAction(request, response)
	return
}

// EnableBackupLogWithChan invokes the dbs.EnableBackupLog API asynchronously
func (client *Client) EnableBackupLogWithChan(request *EnableBackupLogRequest) (<-chan *EnableBackupLogResponse, <-chan error) {
	responseChan := make(chan *EnableBackupLogResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EnableBackupLog(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EnableBackupLogWithCallback invokes the dbs.EnableBackupLog API asynchronously
func (client *Client) EnableBackupLogWithCallback(request *EnableBackupLogRequest, callback func(response *EnableBackupLogResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EnableBackupLogResponse
		var err error
		defer close(result)
		response, err = client.EnableBackupLog(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EnableBackupLogRequest is the request struct for api EnableBackupLog
type EnableBackupLogRequest struct {
	*requests.RpcRequest
	ClientToken  string `position:"Query" name:"ClientToken"`
	BackupPlanId string `position:"Query" name:"BackupPlanId"`
	OwnerId      string `position:"Query" name:"OwnerId"`
}

// EnableBackupLogResponse is the response struct for api EnableBackupLog
type EnableBackupLogResponse struct {
	*responses.BaseResponse
	Success        bool   `json:"Success" xml:"Success"`
	ErrCode        string `json:"ErrCode" xml:"ErrCode"`
	ErrMessage     string `json:"ErrMessage" xml:"ErrMessage"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
	BackupPlanId   string `json:"BackupPlanId" xml:"BackupPlanId"`
	NeedPrecheck   bool   `json:"NeedPrecheck" xml:"NeedPrecheck"`
}

// CreateEnableBackupLogRequest creates a request to invoke EnableBackupLog API
func CreateEnableBackupLogRequest() (request *EnableBackupLogRequest) {
	request = &EnableBackupLogRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dbs", "2019-03-06", "EnableBackupLog", "cbs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateEnableBackupLogResponse creates a response to parse from EnableBackupLog response
func CreateEnableBackupLogResponse() (response *EnableBackupLogResponse) {
	response = &EnableBackupLogResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
