package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDcdnSecSpecInfo invokes the dcdn.DescribeDcdnSecSpecInfo API synchronously
func (client *Client) DescribeDcdnSecSpecInfo(request *DescribeDcdnSecSpecInfoRequest) (response *DescribeDcdnSecSpecInfoResponse, err error) {
	response = CreateDescribeDcdnSecSpecInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDcdnSecSpecInfoWithChan invokes the dcdn.DescribeDcdnSecSpecInfo API asynchronously
func (client *Client) DescribeDcdnSecSpecInfoWithChan(request *DescribeDcdnSecSpecInfoRequest) (<-chan *DescribeDcdnSecSpecInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeDcdnSecSpecInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDcdnSecSpecInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDcdnSecSpecInfoWithCallback invokes the dcdn.DescribeDcdnSecSpecInfo API asynchronously
func (client *Client) DescribeDcdnSecSpecInfoWithCallback(request *DescribeDcdnSecSpecInfoRequest, callback func(response *DescribeDcdnSecSpecInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDcdnSecSpecInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeDcdnSecSpecInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDcdnSecSpecInfoRequest is the request struct for api DescribeDcdnSecSpecInfo
type DescribeDcdnSecSpecInfoRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeDcdnSecSpecInfoResponse is the response struct for api DescribeDcdnSecSpecInfo
type DescribeDcdnSecSpecInfoResponse struct {
	*responses.BaseResponse
	RequestId string         `json:"RequestId" xml:"RequestId"`
	Version   string         `json:"Version" xml:"Version"`
	SpecInfos []RuleInfoItem `json:"SpecInfos" xml:"SpecInfos"`
}

// CreateDescribeDcdnSecSpecInfoRequest creates a request to invoke DescribeDcdnSecSpecInfo API
func CreateDescribeDcdnSecSpecInfoRequest() (request *DescribeDcdnSecSpecInfoRequest) {
	request = &DescribeDcdnSecSpecInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DescribeDcdnSecSpecInfo", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeDcdnSecSpecInfoResponse creates a response to parse from DescribeDcdnSecSpecInfo response
func CreateDescribeDcdnSecSpecInfoResponse() (response *DescribeDcdnSecSpecInfoResponse) {
	response = &DescribeDcdnSecSpecInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
