package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ConfigLayer7Cert invokes the ddoscoo.ConfigLayer7Cert API synchronously
func (client *Client) ConfigLayer7Cert(request *ConfigLayer7CertRequest) (response *ConfigLayer7CertResponse, err error) {
	response = CreateConfigLayer7CertResponse()
	err = client.DoAction(request, response)
	return
}

// ConfigLayer7CertWithChan invokes the ddoscoo.ConfigLayer7Cert API asynchronously
func (client *Client) ConfigLayer7CertWithChan(request *ConfigLayer7CertRequest) (<-chan *ConfigLayer7CertResponse, <-chan error) {
	responseChan := make(chan *ConfigLayer7CertResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ConfigLayer7Cert(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ConfigLayer7CertWithCallback invokes the ddoscoo.ConfigLayer7Cert API asynchronously
func (client *Client) ConfigLayer7CertWithCallback(request *ConfigLayer7CertRequest, callback func(response *ConfigLayer7CertResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ConfigLayer7CertResponse
		var err error
		defer close(result)
		response, err = client.ConfigLayer7Cert(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ConfigLayer7CertRequest is the request struct for api ConfigLayer7Cert
type ConfigLayer7CertRequest struct {
	*requests.RpcRequest
	Cert            string           `position:"Query" name:"Cert"`
	CertId          requests.Integer `position:"Query" name:"CertId"`
	ResourceGroupId string           `position:"Query" name:"ResourceGroupId"`
	SourceIp        string           `position:"Query" name:"SourceIp"`
	Key             string           `position:"Query" name:"Key"`
	CertName        string           `position:"Query" name:"CertName"`
	Domain          string           `position:"Query" name:"Domain"`
}

// ConfigLayer7CertResponse is the response struct for api ConfigLayer7Cert
type ConfigLayer7CertResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateConfigLayer7CertRequest creates a request to invoke ConfigLayer7Cert API
func CreateConfigLayer7CertRequest() (request *ConfigLayer7CertRequest) {
	request = &ConfigLayer7CertRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2017-12-28", "ConfigLayer7Cert", "", "")
	request.Method = requests.POST
	return
}

// CreateConfigLayer7CertResponse creates a response to parse from ConfigLayer7Cert response
func CreateConfigLayer7CertResponse() (response *ConfigLayer7CertResponse) {
	response = &ConfigLayer7CertResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
