package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DisableLayer7CCRule invokes the ddoscoo.DisableLayer7CCRule API synchronously
func (client *Client) DisableLayer7CCRule(request *DisableLayer7CCRuleRequest) (response *DisableLayer7CCRuleResponse, err error) {
	response = CreateDisableLayer7CCRuleResponse()
	err = client.DoAction(request, response)
	return
}

// DisableLayer7CCRuleWithChan invokes the ddoscoo.DisableLayer7CCRule API asynchronously
func (client *Client) DisableLayer7CCRuleWithChan(request *DisableLayer7CCRuleRequest) (<-chan *DisableLayer7CCRuleResponse, <-chan error) {
	responseChan := make(chan *DisableLayer7CCRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DisableLayer7CCRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DisableLayer7CCRuleWithCallback invokes the ddoscoo.DisableLayer7CCRule API asynchronously
func (client *Client) DisableLayer7CCRuleWithCallback(request *DisableLayer7CCRuleRequest, callback func(response *DisableLayer7CCRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DisableLayer7CCRuleResponse
		var err error
		defer close(result)
		response, err = client.DisableLayer7CCRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DisableLayer7CCRuleRequest is the request struct for api DisableLayer7CCRule
type DisableLayer7CCRuleRequest struct {
	*requests.RpcRequest
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	Domain          string `position:"Query" name:"Domain"`
}

// DisableLayer7CCRuleResponse is the response struct for api DisableLayer7CCRule
type DisableLayer7CCRuleResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDisableLayer7CCRuleRequest creates a request to invoke DisableLayer7CCRule API
func CreateDisableLayer7CCRuleRequest() (request *DisableLayer7CCRuleRequest) {
	request = &DisableLayer7CCRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2017-12-28", "DisableLayer7CCRule", "", "")
	request.Method = requests.POST
	return
}

// CreateDisableLayer7CCRuleResponse creates a response to parse from DisableLayer7CCRule response
func CreateDisableLayer7CCRuleResponse() (response *DisableLayer7CCRuleResponse) {
	response = &DisableLayer7CCRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
