package devops_rdc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetDevopsProjectInfo invokes the devops_rdc.GetDevopsProjectInfo API synchronously
func (client *Client) GetDevopsProjectInfo(request *GetDevopsProjectInfoRequest) (response *GetDevopsProjectInfoResponse, err error) {
	response = CreateGetDevopsProjectInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetDevopsProjectInfoWithChan invokes the devops_rdc.GetDevopsProjectInfo API asynchronously
func (client *Client) GetDevopsProjectInfoWithChan(request *GetDevopsProjectInfoRequest) (<-chan *GetDevopsProjectInfoResponse, <-chan error) {
	responseChan := make(chan *GetDevopsProjectInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetDevopsProjectInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetDevopsProjectInfoWithCallback invokes the devops_rdc.GetDevopsProjectInfo API asynchronously
func (client *Client) GetDevopsProjectInfoWithCallback(request *GetDevopsProjectInfoRequest, callback func(response *GetDevopsProjectInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetDevopsProjectInfoResponse
		var err error
		defer close(result)
		response, err = client.GetDevopsProjectInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetDevopsProjectInfoRequest is the request struct for api GetDevopsProjectInfo
type GetDevopsProjectInfoRequest struct {
	*requests.RpcRequest
	ProjectId string `position:"Body" name:"ProjectId"`
	OrgId     string `position:"Body" name:"OrgId"`
}

// GetDevopsProjectInfoResponse is the response struct for api GetDevopsProjectInfo
type GetDevopsProjectInfoResponse struct {
	*responses.BaseResponse
	Successful bool   `json:"Successful" xml:"Successful"`
	ErrorCode  string `json:"ErrorCode" xml:"ErrorCode"`
	ErrorMsg   string `json:"ErrorMsg" xml:"ErrorMsg"`
	RequestId  string `json:"RequestId" xml:"RequestId"`
	Object     Object `json:"Object" xml:"Object"`
}

// CreateGetDevopsProjectInfoRequest creates a request to invoke GetDevopsProjectInfo API
func CreateGetDevopsProjectInfoRequest() (request *GetDevopsProjectInfoRequest) {
	request = &GetDevopsProjectInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("devops-rdc", "2020-03-03", "GetDevopsProjectInfo", "", "")
	request.Method = requests.POST
	return
}

// CreateGetDevopsProjectInfoResponse creates a response to parse from GetDevopsProjectInfo response
func CreateGetDevopsProjectInfoResponse() (response *GetDevopsProjectInfoResponse) {
	response = &GetDevopsProjectInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
