package dm

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryReceiverByParam invokes the dm.QueryReceiverByParam API synchronously
// api document: https://help.aliyun.com/api/dm/queryreceiverbyparam.html
func (client *Client) QueryReceiverByParam(request *QueryReceiverByParamRequest) (response *QueryReceiverByParamResponse, err error) {
	response = CreateQueryReceiverByParamResponse()
	err = client.DoAction(request, response)
	return
}

// QueryReceiverByParamWithChan invokes the dm.QueryReceiverByParam API asynchronously
// api document: https://help.aliyun.com/api/dm/queryreceiverbyparam.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryReceiverByParamWithChan(request *QueryReceiverByParamRequest) (<-chan *QueryReceiverByParamResponse, <-chan error) {
	responseChan := make(chan *QueryReceiverByParamResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryReceiverByParam(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryReceiverByParamWithCallback invokes the dm.QueryReceiverByParam API asynchronously
// api document: https://help.aliyun.com/api/dm/queryreceiverbyparam.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryReceiverByParamWithCallback(request *QueryReceiverByParamRequest, callback func(response *QueryReceiverByParamResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryReceiverByParamResponse
		var err error
		defer close(result)
		response, err = client.QueryReceiverByParam(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryReceiverByParamRequest is the request struct for api QueryReceiverByParam
type QueryReceiverByParamRequest struct {
	*requests.RpcRequest
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	PageNo               requests.Integer `position:"Query" name:"PageNo"`
	PageSize             requests.Integer `position:"Query" name:"PageSize"`
	KeyWord              string           `position:"Query" name:"KeyWord"`
	Status               requests.Integer `position:"Query" name:"Status"`
}

// QueryReceiverByParamResponse is the response struct for api QueryReceiverByParam
type QueryReceiverByParamResponse struct {
	*responses.BaseResponse
	RequestId  string                     `json:"RequestId" xml:"RequestId"`
	TotalCount int                        `json:"TotalCount" xml:"TotalCount"`
	NextStart  string                     `json:"NextStart" xml:"NextStart"`
	PageSize   int                        `json:"PageSize" xml:"PageSize"`
	Data       DataInQueryReceiverByParam `json:"data" xml:"data"`
}

// CreateQueryReceiverByParamRequest creates a request to invoke QueryReceiverByParam API
func CreateQueryReceiverByParamRequest() (request *QueryReceiverByParamRequest) {
	request = &QueryReceiverByParamRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dm", "2015-11-23", "QueryReceiverByParam", "", "")
	return
}

// CreateQueryReceiverByParamResponse creates a response to parse from QueryReceiverByParam response
func CreateQueryReceiverByParamResponse() (response *QueryReceiverByParamResponse) {
	response = &QueryReceiverByParamResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
