package dypnsapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetAuthorizationUrl invokes the dypnsapi.GetAuthorizationUrl API synchronously
func (client *Client) GetAuthorizationUrl(request *GetAuthorizationUrlRequest) (response *GetAuthorizationUrlResponse, err error) {
	response = CreateGetAuthorizationUrlResponse()
	err = client.DoAction(request, response)
	return
}

// GetAuthorizationUrlWithChan invokes the dypnsapi.GetAuthorizationUrl API asynchronously
func (client *Client) GetAuthorizationUrlWithChan(request *GetAuthorizationUrlRequest) (<-chan *GetAuthorizationUrlResponse, <-chan error) {
	responseChan := make(chan *GetAuthorizationUrlResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetAuthorizationUrl(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetAuthorizationUrlWithCallback invokes the dypnsapi.GetAuthorizationUrl API asynchronously
func (client *Client) GetAuthorizationUrlWithCallback(request *GetAuthorizationUrlRequest, callback func(response *GetAuthorizationUrlResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetAuthorizationUrlResponse
		var err error
		defer close(result)
		response, err = client.GetAuthorizationUrl(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetAuthorizationUrlRequest is the request struct for api GetAuthorizationUrl
type GetAuthorizationUrlRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	SchemeId             requests.Integer `position:"Query" name:"SchemeId"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	PhoneNo              string           `position:"Query" name:"PhoneNo"`
	EndDate              string           `position:"Query" name:"EndDate"`
}

// GetAuthorizationUrlResponse is the response struct for api GetAuthorizationUrl
type GetAuthorizationUrlResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateGetAuthorizationUrlRequest creates a request to invoke GetAuthorizationUrl API
func CreateGetAuthorizationUrlRequest() (request *GetAuthorizationUrlRequest) {
	request = &GetAuthorizationUrlRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dypnsapi", "2017-05-25", "GetAuthorizationUrl", "", "")
	request.Method = requests.POST
	return
}

// CreateGetAuthorizationUrlResponse creates a response to parse from GetAuthorizationUrl response
func CreateGetAuthorizationUrlResponse() (response *GetAuthorizationUrlResponse) {
	response = &GetAuthorizationUrlResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
