package edas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateEnvHttpTrafficControl invokes the edas.CreateEnvHttpTrafficControl API synchronously
func (client *Client) CreateEnvHttpTrafficControl(request *CreateEnvHttpTrafficControlRequest) (response *CreateEnvHttpTrafficControlResponse, err error) {
	response = CreateCreateEnvHttpTrafficControlResponse()
	err = client.DoAction(request, response)
	return
}

// CreateEnvHttpTrafficControlWithChan invokes the edas.CreateEnvHttpTrafficControl API asynchronously
func (client *Client) CreateEnvHttpTrafficControlWithChan(request *CreateEnvHttpTrafficControlRequest) (<-chan *CreateEnvHttpTrafficControlResponse, <-chan error) {
	responseChan := make(chan *CreateEnvHttpTrafficControlResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateEnvHttpTrafficControl(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateEnvHttpTrafficControlWithCallback invokes the edas.CreateEnvHttpTrafficControl API asynchronously
func (client *Client) CreateEnvHttpTrafficControlWithCallback(request *CreateEnvHttpTrafficControlRequest, callback func(response *CreateEnvHttpTrafficControlResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateEnvHttpTrafficControlResponse
		var err error
		defer close(result)
		response, err = client.CreateEnvHttpTrafficControl(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateEnvHttpTrafficControlRequest is the request struct for api CreateEnvHttpTrafficControl
type CreateEnvHttpTrafficControlRequest struct {
	*requests.RoaRequest
	Condition       string `position:"Body" name:"Condition"`
	UrlPath         string `position:"Body" name:"UrlPath"`
	AppId           string `position:"Body" name:"AppId"`
	LabelAdviceName string `position:"Body" name:"LabelAdviceName"`
	PointcutName    string `position:"Body" name:"PointcutName"`
	TriggerPolicy   string `position:"Body" name:"TriggerPolicy"`
}

// CreateEnvHttpTrafficControlResponse is the response struct for api CreateEnvHttpTrafficControl
type CreateEnvHttpTrafficControlResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      int    `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateCreateEnvHttpTrafficControlRequest creates a request to invoke CreateEnvHttpTrafficControl API
func CreateCreateEnvHttpTrafficControlRequest() (request *CreateEnvHttpTrafficControlRequest) {
	request = &CreateEnvHttpTrafficControlRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("Edas", "2017-08-01", "CreateEnvHttpTrafficControl", "/pop/v5/gray/env_http_traffic_control", "edas", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateEnvHttpTrafficControlResponse creates a response to parse from CreateEnvHttpTrafficControl response
func CreateCreateEnvHttpTrafficControlResponse() (response *CreateEnvHttpTrafficControlResponse) {
	response = &CreateEnvHttpTrafficControlResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
