package edas

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListConsumedServices invokes the edas.ListConsumedServices API synchronously
func (client *Client) ListConsumedServices(request *ListConsumedServicesRequest) (response *ListConsumedServicesResponse, err error) {
	response = CreateListConsumedServicesResponse()
	err = client.DoAction(request, response)
	return
}

// ListConsumedServicesWithChan invokes the edas.ListConsumedServices API asynchronously
func (client *Client) ListConsumedServicesWithChan(request *ListConsumedServicesRequest) (<-chan *ListConsumedServicesResponse, <-chan error) {
	responseChan := make(chan *ListConsumedServicesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListConsumedServices(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListConsumedServicesWithCallback invokes the edas.ListConsumedServices API asynchronously
func (client *Client) ListConsumedServicesWithCallback(request *ListConsumedServicesRequest, callback func(response *ListConsumedServicesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListConsumedServicesResponse
		var err error
		defer close(result)
		response, err = client.ListConsumedServices(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListConsumedServicesRequest is the request struct for api ListConsumedServices
type ListConsumedServicesRequest struct {
	*requests.RoaRequest
	AppId string `position:"Query" name:"AppId"`
}

// ListConsumedServicesResponse is the response struct for api ListConsumedServices
type ListConsumedServicesResponse struct {
	*responses.BaseResponse
	Code                 int                  `json:"Code" xml:"Code"`
	Message              string               `json:"Message" xml:"Message"`
	RequestId            string               `json:"RequestId" xml:"RequestId"`
	ConsumedServicesList ConsumedServicesList `json:"ConsumedServicesList" xml:"ConsumedServicesList"`
}

// CreateListConsumedServicesRequest creates a request to invoke ListConsumedServices API
func CreateListConsumedServicesRequest() (request *ListConsumedServicesRequest) {
	request = &ListConsumedServicesRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("Edas", "2017-08-01", "ListConsumedServices", "/pop/v5/service/listConsumedServices", "edas", "openAPI")
	request.Method = requests.GET
	return
}

// CreateListConsumedServicesResponse creates a response to parse from ListConsumedServices response
func CreateListConsumedServicesResponse() (response *ListConsumedServicesResponse) {
	response = &ListConsumedServicesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
