package ehpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListSoftwares invokes the ehpc.ListSoftwares API synchronously
func (client *Client) ListSoftwares(request *ListSoftwaresRequest) (response *ListSoftwaresResponse, err error) {
	response = CreateListSoftwaresResponse()
	err = client.DoAction(request, response)
	return
}

// ListSoftwaresWithChan invokes the ehpc.ListSoftwares API asynchronously
func (client *Client) ListSoftwaresWithChan(request *ListSoftwaresRequest) (<-chan *ListSoftwaresResponse, <-chan error) {
	responseChan := make(chan *ListSoftwaresResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListSoftwares(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListSoftwaresWithCallback invokes the ehpc.ListSoftwares API asynchronously
func (client *Client) ListSoftwaresWithCallback(request *ListSoftwaresRequest, callback func(response *ListSoftwaresResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListSoftwaresResponse
		var err error
		defer close(result)
		response, err = client.ListSoftwares(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListSoftwaresRequest is the request struct for api ListSoftwares
type ListSoftwaresRequest struct {
	*requests.RpcRequest
	OsTag       string `position:"Query" name:"OsTag"`
	EhpcVersion string `position:"Query" name:"EhpcVersion"`
}

// ListSoftwaresResponse is the response struct for api ListSoftwares
type ListSoftwaresResponse struct {
	*responses.BaseResponse
	RequestId string    `json:"RequestId" xml:"RequestId"`
	Softwares Softwares `json:"Softwares" xml:"Softwares"`
}

// CreateListSoftwaresRequest creates a request to invoke ListSoftwares API
func CreateListSoftwaresRequest() (request *ListSoftwaresRequest) {
	request = &ListSoftwaresRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("EHPC", "2018-04-12", "ListSoftwares", "", "")
	request.Method = requests.GET
	return
}

// CreateListSoftwaresResponse creates a response to parse from ListSoftwares response
func CreateListSoftwaresResponse() (response *ListSoftwaresResponse) {
	response = &ListSoftwaresResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
