package elasticsearch

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateAliwsDict invokes the elasticsearch.UpdateAliwsDict API synchronously
func (client *Client) UpdateAliwsDict(request *UpdateAliwsDictRequest) (response *UpdateAliwsDictResponse, err error) {
	response = CreateUpdateAliwsDictResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateAliwsDictWithChan invokes the elasticsearch.UpdateAliwsDict API asynchronously
func (client *Client) UpdateAliwsDictWithChan(request *UpdateAliwsDictRequest) (<-chan *UpdateAliwsDictResponse, <-chan error) {
	responseChan := make(chan *UpdateAliwsDictResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateAliwsDict(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateAliwsDictWithCallback invokes the elasticsearch.UpdateAliwsDict API asynchronously
func (client *Client) UpdateAliwsDictWithCallback(request *UpdateAliwsDictRequest, callback func(response *UpdateAliwsDictResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateAliwsDictResponse
		var err error
		defer close(result)
		response, err = client.UpdateAliwsDict(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateAliwsDictRequest is the request struct for api UpdateAliwsDict
type UpdateAliwsDictRequest struct {
	*requests.RoaRequest
	InstanceId  string `position:"Path" name:"InstanceId"`
	ClientToken string `position:"Query" name:"clientToken"`
}

// UpdateAliwsDictResponse is the response struct for api UpdateAliwsDict
type UpdateAliwsDictResponse struct {
	*responses.BaseResponse
	RequestId string     `json:"RequestId" xml:"RequestId"`
	Result    []DictList `json:"Result" xml:"Result"`
}

// CreateUpdateAliwsDictRequest creates a request to invoke UpdateAliwsDict API
func CreateUpdateAliwsDictRequest() (request *UpdateAliwsDictRequest) {
	request = &UpdateAliwsDictRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("elasticsearch", "2017-06-13", "UpdateAliwsDict", "/openapi/instances/[InstanceId]/aliws-dict", "elasticsearch", "openAPI")
	request.Method = requests.PUT
	return
}

// CreateUpdateAliwsDictResponse creates a response to parse from UpdateAliwsDict response
func CreateUpdateAliwsDictResponse() (response *UpdateAliwsDictResponse) {
	response = &UpdateAliwsDictResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
