package elasticsearch

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateCollectorName invokes the elasticsearch.UpdateCollectorName API synchronously
func (client *Client) UpdateCollectorName(request *UpdateCollectorNameRequest) (response *UpdateCollectorNameResponse, err error) {
	response = CreateUpdateCollectorNameResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateCollectorNameWithChan invokes the elasticsearch.UpdateCollectorName API asynchronously
func (client *Client) UpdateCollectorNameWithChan(request *UpdateCollectorNameRequest) (<-chan *UpdateCollectorNameResponse, <-chan error) {
	responseChan := make(chan *UpdateCollectorNameResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateCollectorName(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateCollectorNameWithCallback invokes the elasticsearch.UpdateCollectorName API asynchronously
func (client *Client) UpdateCollectorNameWithCallback(request *UpdateCollectorNameRequest, callback func(response *UpdateCollectorNameResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateCollectorNameResponse
		var err error
		defer close(result)
		response, err = client.UpdateCollectorName(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateCollectorNameRequest is the request struct for api UpdateCollectorName
type UpdateCollectorNameRequest struct {
	*requests.RoaRequest
	ClientToken string `position:"Query" name:"ClientToken"`
	ResId       string `position:"Path" name:"ResId"`
}

// UpdateCollectorNameResponse is the response struct for api UpdateCollectorName
type UpdateCollectorNameResponse struct {
	*responses.BaseResponse
	RequestId string                      `json:"RequestId" xml:"RequestId"`
	Result    ResultInUpdateCollectorName `json:"Result" xml:"Result"`
}

// CreateUpdateCollectorNameRequest creates a request to invoke UpdateCollectorName API
func CreateUpdateCollectorNameRequest() (request *UpdateCollectorNameRequest) {
	request = &UpdateCollectorNameRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("elasticsearch", "2017-06-13", "UpdateCollectorName", "/openapi/collectors/[ResId]/actions/rename", "elasticsearch", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateCollectorNameResponse creates a response to parse from UpdateCollectorName response
func CreateUpdateCollectorNameResponse() (response *UpdateCollectorNameResponse) {
	response = &UpdateCollectorNameResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
