package elasticsearch

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateExtendfiles invokes the elasticsearch.UpdateExtendfiles API synchronously
func (client *Client) UpdateExtendfiles(request *UpdateExtendfilesRequest) (response *UpdateExtendfilesResponse, err error) {
	response = CreateUpdateExtendfilesResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateExtendfilesWithChan invokes the elasticsearch.UpdateExtendfiles API asynchronously
func (client *Client) UpdateExtendfilesWithChan(request *UpdateExtendfilesRequest) (<-chan *UpdateExtendfilesResponse, <-chan error) {
	responseChan := make(chan *UpdateExtendfilesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateExtendfiles(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateExtendfilesWithCallback invokes the elasticsearch.UpdateExtendfiles API asynchronously
func (client *Client) UpdateExtendfilesWithCallback(request *UpdateExtendfilesRequest, callback func(response *UpdateExtendfilesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateExtendfilesResponse
		var err error
		defer close(result)
		response, err = client.UpdateExtendfiles(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateExtendfilesRequest is the request struct for api UpdateExtendfiles
type UpdateExtendfilesRequest struct {
	*requests.RoaRequest
	InstanceId  string `position:"Path" name:"InstanceId"`
	ClientToken string `position:"Query" name:"ClientToken"`
}

// UpdateExtendfilesResponse is the response struct for api UpdateExtendfiles
type UpdateExtendfilesResponse struct {
	*responses.BaseResponse
	RequestId string       `json:"RequestId" xml:"RequestId"`
	Result    []ResultItem `json:"Result" xml:"Result"`
}

// CreateUpdateExtendfilesRequest creates a request to invoke UpdateExtendfiles API
func CreateUpdateExtendfilesRequest() (request *UpdateExtendfilesRequest) {
	request = &UpdateExtendfilesRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("elasticsearch", "2017-06-13", "UpdateExtendfiles", "/openapi/logstashes/[InstanceId]/extendfiles", "elasticsearch", "openAPI")
	request.Method = requests.PUT
	return
}

// CreateUpdateExtendfilesResponse creates a response to parse from UpdateExtendfiles response
func CreateUpdateExtendfilesResponse() (response *UpdateExtendfilesResponse) {
	response = &UpdateExtendfilesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
