package facebody

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RetouchBody invokes the facebody.RetouchBody API synchronously
func (client *Client) RetouchBody(request *RetouchBodyRequest) (response *RetouchBodyResponse, err error) {
	response = CreateRetouchBodyResponse()
	err = client.DoAction(request, response)
	return
}

// RetouchBodyWithChan invokes the facebody.RetouchBody API asynchronously
func (client *Client) RetouchBodyWithChan(request *RetouchBodyRequest) (<-chan *RetouchBodyResponse, <-chan error) {
	responseChan := make(chan *RetouchBodyResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RetouchBody(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RetouchBodyWithCallback invokes the facebody.RetouchBody API asynchronously
func (client *Client) RetouchBodyWithCallback(request *RetouchBodyRequest, callback func(response *RetouchBodyResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RetouchBodyResponse
		var err error
		defer close(result)
		response, err = client.RetouchBody(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RetouchBodyRequest is the request struct for api RetouchBody
type RetouchBodyRequest struct {
	*requests.RpcRequest
	LengthenDegree requests.Float `position:"Body" name:"LengthenDegree"`
	SlimDegree     requests.Float `position:"Body" name:"SlimDegree"`
	ImageURL       string         `position:"Body" name:"ImageURL"`
}

// RetouchBodyResponse is the response struct for api RetouchBody
type RetouchBodyResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateRetouchBodyRequest creates a request to invoke RetouchBody API
func CreateRetouchBodyRequest() (request *RetouchBodyRequest) {
	request = &RetouchBodyRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("facebody", "2019-12-30", "RetouchBody", "facebody", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRetouchBodyResponse creates a response to parse from RetouchBody response
func CreateRetouchBodyResponse() (response *RetouchBodyResponse) {
	response = &RetouchBodyResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
