package fnf

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateFlow invokes the fnf.CreateFlow API synchronously
func (client *Client) CreateFlow(request *CreateFlowRequest) (response *CreateFlowResponse, err error) {
	response = CreateCreateFlowResponse()
	err = client.DoAction(request, response)
	return
}

// CreateFlowWithChan invokes the fnf.CreateFlow API asynchronously
func (client *Client) CreateFlowWithChan(request *CreateFlowRequest) (<-chan *CreateFlowResponse, <-chan error) {
	responseChan := make(chan *CreateFlowResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateFlow(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateFlowWithCallback invokes the fnf.CreateFlow API asynchronously
func (client *Client) CreateFlowWithCallback(request *CreateFlowRequest, callback func(response *CreateFlowResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateFlowResponse
		var err error
		defer close(result)
		response, err = client.CreateFlow(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateFlowRequest is the request struct for api CreateFlow
type CreateFlowRequest struct {
	*requests.RpcRequest
	Description             string `position:"Body" name:"Description"`
	Type                    string `position:"Body" name:"Type"`
	RequestId               string `position:"Query" name:"RequestId"`
	RoleArn                 string `position:"Body" name:"RoleArn"`
	Name                    string `position:"Body" name:"Name"`
	Definition              string `position:"Body" name:"Definition"`
	ExternalStorageLocation string `position:"Body" name:"ExternalStorageLocation"`
}

// CreateFlowResponse is the response struct for api CreateFlow
type CreateFlowResponse struct {
	*responses.BaseResponse
	RequestId               string `json:"RequestId" xml:"RequestId"`
	Name                    string `json:"Name" xml:"Name"`
	Description             string `json:"Description" xml:"Description"`
	Definition              string `json:"Definition" xml:"Definition"`
	Id                      string `json:"Id" xml:"Id"`
	Type                    string `json:"Type" xml:"Type"`
	RoleArn                 string `json:"RoleArn" xml:"RoleArn"`
	CreatedTime             string `json:"CreatedTime" xml:"CreatedTime"`
	LastModifiedTime        string `json:"LastModifiedTime" xml:"LastModifiedTime"`
	ExternalStorageLocation string `json:"ExternalStorageLocation" xml:"ExternalStorageLocation"`
}

// CreateCreateFlowRequest creates a request to invoke CreateFlow API
func CreateCreateFlowRequest() (request *CreateFlowRequest) {
	request = &CreateFlowRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("fnf", "2019-03-15", "CreateFlow", "fnf", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateFlowResponse creates a response to parse from CreateFlow response
func CreateCreateFlowResponse() (response *CreateFlowResponse) {
	response = &CreateFlowResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
