package idrsservice

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListRules invokes the idrsservice.ListRules API synchronously
func (client *Client) ListRules(request *ListRulesRequest) (response *ListRulesResponse, err error) {
	response = CreateListRulesResponse()
	err = client.DoAction(request, response)
	return
}

// ListRulesWithChan invokes the idrsservice.ListRules API asynchronously
func (client *Client) ListRulesWithChan(request *ListRulesRequest) (<-chan *ListRulesResponse, <-chan error) {
	responseChan := make(chan *ListRulesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListRules(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListRulesWithCallback invokes the idrsservice.ListRules API asynchronously
func (client *Client) ListRulesWithCallback(request *ListRulesRequest, callback func(response *ListRulesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListRulesResponse
		var err error
		defer close(result)
		response, err = client.ListRules(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListRulesRequest is the request struct for api ListRules
type ListRulesRequest struct {
	*requests.RpcRequest
	PageSize  requests.Integer `position:"Query" name:"PageSize"`
	PageIndex requests.Integer `position:"Query" name:"PageIndex"`
}

// ListRulesResponse is the response struct for api ListRules
type ListRulesResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateListRulesRequest creates a request to invoke ListRules API
func CreateListRulesRequest() (request *ListRulesRequest) {
	request = &ListRulesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("idrsservice", "2020-06-30", "ListRules", "idrsservice", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListRulesResponse creates a response to parse from ListRules response
func CreateListRulesResponse() (response *ListRulesResponse) {
	response = &ListRulesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
