package imm

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteSet invokes the imm.DeleteSet API synchronously
func (client *Client) DeleteSet(request *DeleteSetRequest) (response *DeleteSetResponse, err error) {
	response = CreateDeleteSetResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteSetWithChan invokes the imm.DeleteSet API asynchronously
func (client *Client) DeleteSetWithChan(request *DeleteSetRequest) (<-chan *DeleteSetResponse, <-chan error) {
	responseChan := make(chan *DeleteSetResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteSet(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteSetWithCallback invokes the imm.DeleteSet API asynchronously
func (client *Client) DeleteSetWithCallback(request *DeleteSetRequest, callback func(response *DeleteSetResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteSetResponse
		var err error
		defer close(result)
		response, err = client.DeleteSet(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteSetRequest is the request struct for api DeleteSet
type DeleteSetRequest struct {
	*requests.RpcRequest
	Project string `position:"Query" name:"Project"`
	SetId   string `position:"Query" name:"SetId"`
}

// DeleteSetResponse is the response struct for api DeleteSet
type DeleteSetResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	SetId     string `json:"SetId" xml:"SetId"`
}

// CreateDeleteSetRequest creates a request to invoke DeleteSet API
func CreateDeleteSetRequest() (request *DeleteSetRequest) {
	request = &DeleteSetRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("imm", "2017-09-06", "DeleteSet", "imm", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteSetResponse creates a response to parse from DeleteSet response
func CreateDeleteSetResponse() (response *DeleteSetResponse) {
	response = &DeleteSetResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
