package imm

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateImage invokes the imm.UpdateImage API synchronously
func (client *Client) UpdateImage(request *UpdateImageRequest) (response *UpdateImageResponse, err error) {
	response = CreateUpdateImageResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateImageWithChan invokes the imm.UpdateImage API asynchronously
func (client *Client) UpdateImageWithChan(request *UpdateImageRequest) (<-chan *UpdateImageResponse, <-chan error) {
	responseChan := make(chan *UpdateImageResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateImage(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateImageWithCallback invokes the imm.UpdateImage API asynchronously
func (client *Client) UpdateImageWithCallback(request *UpdateImageRequest, callback func(response *UpdateImageResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateImageResponse
		var err error
		defer close(result)
		response, err = client.UpdateImage(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateImageRequest is the request struct for api UpdateImage
type UpdateImageRequest struct {
	*requests.RpcRequest
	Project        string              `position:"Query" name:"Project"`
	ExternalId     string              `position:"Query" name:"ExternalId"`
	SourceType     string              `position:"Query" name:"SourceType"`
	RemarksB       string              `position:"Query" name:"RemarksB"`
	RemarksA       string              `position:"Query" name:"RemarksA"`
	ImageUri       string              `position:"Query" name:"ImageUri"`
	RemarksArrayA  string              `position:"Query" name:"RemarksArrayA"`
	RemarksArrayB  string              `position:"Query" name:"RemarksArrayB"`
	SourceUri      string              `position:"Query" name:"SourceUri"`
	SourcePosition string              `position:"Query" name:"SourcePosition"`
	RemarksD       string              `position:"Query" name:"RemarksD"`
	RemarksC       string              `position:"Query" name:"RemarksC"`
	SetId          string              `position:"Query" name:"SetId"`
	Faces          *[]UpdateImageFaces `position:"Query" name:"Faces"  type:"Json"`
}

// UpdateImageFaces is a repeated param struct in UpdateImageRequest
type UpdateImageFaces struct {
	GroupId string `name:"GroupId"`
	FaceId  string `name:"FaceId"`
}

// UpdateImageResponse is the response struct for api UpdateImage
type UpdateImageResponse struct {
	*responses.BaseResponse
	RemarksArrayB string `json:"RemarksArrayB" xml:"RemarksArrayB"`
	ModifyTime    string `json:"ModifyTime" xml:"ModifyTime"`
	RemarksC      string `json:"RemarksC" xml:"RemarksC"`
	RemarksD      string `json:"RemarksD" xml:"RemarksD"`
	RequestId     string `json:"RequestId" xml:"RequestId"`
	CreateTime    string `json:"CreateTime" xml:"CreateTime"`
	ExternalId    string `json:"ExternalId" xml:"ExternalId"`
	RemarksArrayA string `json:"RemarksArrayA" xml:"RemarksArrayA"`
	RemarksA      string `json:"RemarksA" xml:"RemarksA"`
	ImageUri      string `json:"ImageUri" xml:"ImageUri"`
	SetId         string `json:"SetId" xml:"SetId"`
	RemarksB      string `json:"RemarksB" xml:"RemarksB"`
}

// CreateUpdateImageRequest creates a request to invoke UpdateImage API
func CreateUpdateImageRequest() (request *UpdateImageRequest) {
	request = &UpdateImageRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("imm", "2017-09-06", "UpdateImage", "imm", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateImageResponse creates a response to parse from UpdateImage response
func CreateUpdateImageResponse() (response *UpdateImageResponse) {
	response = &UpdateImageResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
