package iot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchCheckDeviceNames invokes the iot.BatchCheckDeviceNames API synchronously
func (client *Client) BatchCheckDeviceNames(request *BatchCheckDeviceNamesRequest) (response *BatchCheckDeviceNamesResponse, err error) {
	response = CreateBatchCheckDeviceNamesResponse()
	err = client.DoAction(request, response)
	return
}

// BatchCheckDeviceNamesWithChan invokes the iot.BatchCheckDeviceNames API asynchronously
func (client *Client) BatchCheckDeviceNamesWithChan(request *BatchCheckDeviceNamesRequest) (<-chan *BatchCheckDeviceNamesResponse, <-chan error) {
	responseChan := make(chan *BatchCheckDeviceNamesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchCheckDeviceNames(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchCheckDeviceNamesWithCallback invokes the iot.BatchCheckDeviceNames API asynchronously
func (client *Client) BatchCheckDeviceNamesWithCallback(request *BatchCheckDeviceNamesRequest, callback func(response *BatchCheckDeviceNamesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchCheckDeviceNamesResponse
		var err error
		defer close(result)
		response, err = client.BatchCheckDeviceNames(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchCheckDeviceNamesRequest is the request struct for api BatchCheckDeviceNames
type BatchCheckDeviceNamesRequest struct {
	*requests.RpcRequest
	RealTenantId      string                                 `position:"Query" name:"RealTenantId"`
	RealTripartiteKey string                                 `position:"Query" name:"RealTripartiteKey"`
	DeviceNameList    *[]BatchCheckDeviceNamesDeviceNameList `position:"Query" name:"DeviceNameList"  type:"Repeated"`
	IotInstanceId     string                                 `position:"Query" name:"IotInstanceId"`
	ProductKey        string                                 `position:"Query" name:"ProductKey"`
	ApiProduct        string                                 `position:"Body" name:"ApiProduct"`
	ApiRevision       string                                 `position:"Body" name:"ApiRevision"`
	DeviceName        *[]string                              `position:"Query" name:"DeviceName"  type:"Repeated"`
}

// BatchCheckDeviceNamesDeviceNameList is a repeated param struct in BatchCheckDeviceNamesRequest
type BatchCheckDeviceNamesDeviceNameList struct {
	DeviceNickname string `name:"DeviceNickname"`
	DeviceName     string `name:"DeviceName"`
}

// BatchCheckDeviceNamesResponse is the response struct for api BatchCheckDeviceNames
type BatchCheckDeviceNamesResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	Success      bool   `json:"Success" xml:"Success"`
	Code         string `json:"Code" xml:"Code"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Data         Data   `json:"Data" xml:"Data"`
}

// CreateBatchCheckDeviceNamesRequest creates a request to invoke BatchCheckDeviceNames API
func CreateBatchCheckDeviceNamesRequest() (request *BatchCheckDeviceNamesRequest) {
	request = &BatchCheckDeviceNamesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Iot", "2018-01-20", "BatchCheckDeviceNames", "iot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateBatchCheckDeviceNamesResponse creates a response to parse from BatchCheckDeviceNames response
func CreateBatchCheckDeviceNamesResponse() (response *BatchCheckDeviceNamesResponse) {
	response = &BatchCheckDeviceNamesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
