package iot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CloseDeviceTunnel invokes the iot.CloseDeviceTunnel API synchronously
func (client *Client) CloseDeviceTunnel(request *CloseDeviceTunnelRequest) (response *CloseDeviceTunnelResponse, err error) {
	response = CreateCloseDeviceTunnelResponse()
	err = client.DoAction(request, response)
	return
}

// CloseDeviceTunnelWithChan invokes the iot.CloseDeviceTunnel API asynchronously
func (client *Client) CloseDeviceTunnelWithChan(request *CloseDeviceTunnelRequest) (<-chan *CloseDeviceTunnelResponse, <-chan error) {
	responseChan := make(chan *CloseDeviceTunnelResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CloseDeviceTunnel(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CloseDeviceTunnelWithCallback invokes the iot.CloseDeviceTunnel API asynchronously
func (client *Client) CloseDeviceTunnelWithCallback(request *CloseDeviceTunnelRequest, callback func(response *CloseDeviceTunnelResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CloseDeviceTunnelResponse
		var err error
		defer close(result)
		response, err = client.CloseDeviceTunnel(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CloseDeviceTunnelRequest is the request struct for api CloseDeviceTunnel
type CloseDeviceTunnelRequest struct {
	*requests.RpcRequest
	IotInstanceId string `position:"Query" name:"IotInstanceId"`
	TunnelId      string `position:"Query" name:"TunnelId"`
	ApiProduct    string `position:"Body" name:"ApiProduct"`
	ApiRevision   string `position:"Body" name:"ApiRevision"`
}

// CloseDeviceTunnelResponse is the response struct for api CloseDeviceTunnel
type CloseDeviceTunnelResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	Success      bool   `json:"Success" xml:"Success"`
	Code         string `json:"Code" xml:"Code"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
}

// CreateCloseDeviceTunnelRequest creates a request to invoke CloseDeviceTunnel API
func CreateCloseDeviceTunnelRequest() (request *CloseDeviceTunnelRequest) {
	request = &CloseDeviceTunnelRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Iot", "2018-01-20", "CloseDeviceTunnel", "iot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCloseDeviceTunnelResponse creates a response to parse from CloseDeviceTunnel response
func CreateCloseDeviceTunnelResponse() (response *CloseDeviceTunnelResponse) {
	response = &CloseDeviceTunnelResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
