package ivpd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HighlightGameVideo invokes the ivpd.HighlightGameVideo API synchronously
// api document: https://help.aliyun.com/api/ivpd/highlightgamevideo.html
func (client *Client) HighlightGameVideo(request *HighlightGameVideoRequest) (response *HighlightGameVideoResponse, err error) {
	response = CreateHighlightGameVideoResponse()
	err = client.DoAction(request, response)
	return
}

// HighlightGameVideoWithChan invokes the ivpd.HighlightGameVideo API asynchronously
// api document: https://help.aliyun.com/api/ivpd/highlightgamevideo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) HighlightGameVideoWithChan(request *HighlightGameVideoRequest) (<-chan *HighlightGameVideoResponse, <-chan error) {
	responseChan := make(chan *HighlightGameVideoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HighlightGameVideo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HighlightGameVideoWithCallback invokes the ivpd.HighlightGameVideo API asynchronously
// api document: https://help.aliyun.com/api/ivpd/highlightgamevideo.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) HighlightGameVideoWithCallback(request *HighlightGameVideoRequest, callback func(response *HighlightGameVideoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HighlightGameVideoResponse
		var err error
		defer close(result)
		response, err = client.HighlightGameVideo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HighlightGameVideoRequest is the request struct for api HighlightGameVideo
type HighlightGameVideoRequest struct {
	*requests.RpcRequest
	Async    requests.Boolean `position:"Body" name:"Async"`
	VideoUrl string           `position:"Body" name:"VideoUrl"`
}

// HighlightGameVideoResponse is the response struct for api HighlightGameVideo
type HighlightGameVideoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateHighlightGameVideoRequest creates a request to invoke HighlightGameVideo API
func CreateHighlightGameVideoRequest() (request *HighlightGameVideoRequest) {
	request = &HighlightGameVideoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ivpd", "2019-06-25", "HighlightGameVideo", "ivpd", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHighlightGameVideoResponse creates a response to parse from HighlightGameVideo response
func CreateHighlightGameVideoResponse() (response *HighlightGameVideoResponse) {
	response = &HighlightGameVideoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
