package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeLiveDomainRealTimeTrafficData invokes the live.DescribeLiveDomainRealTimeTrafficData API synchronously
func (client *Client) DescribeLiveDomainRealTimeTrafficData(request *DescribeLiveDomainRealTimeTrafficDataRequest) (response *DescribeLiveDomainRealTimeTrafficDataResponse, err error) {
	response = CreateDescribeLiveDomainRealTimeTrafficDataResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeLiveDomainRealTimeTrafficDataWithChan invokes the live.DescribeLiveDomainRealTimeTrafficData API asynchronously
func (client *Client) DescribeLiveDomainRealTimeTrafficDataWithChan(request *DescribeLiveDomainRealTimeTrafficDataRequest) (<-chan *DescribeLiveDomainRealTimeTrafficDataResponse, <-chan error) {
	responseChan := make(chan *DescribeLiveDomainRealTimeTrafficDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeLiveDomainRealTimeTrafficData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeLiveDomainRealTimeTrafficDataWithCallback invokes the live.DescribeLiveDomainRealTimeTrafficData API asynchronously
func (client *Client) DescribeLiveDomainRealTimeTrafficDataWithCallback(request *DescribeLiveDomainRealTimeTrafficDataRequest, callback func(response *DescribeLiveDomainRealTimeTrafficDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeLiveDomainRealTimeTrafficDataResponse
		var err error
		defer close(result)
		response, err = client.DescribeLiveDomainRealTimeTrafficData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeLiveDomainRealTimeTrafficDataRequest is the request struct for api DescribeLiveDomainRealTimeTrafficData
type DescribeLiveDomainRealTimeTrafficDataRequest struct {
	*requests.RpcRequest
	LocationNameEn string           `position:"Query" name:"LocationNameEn"`
	StartTime      string           `position:"Query" name:"StartTime"`
	IspNameEn      string           `position:"Query" name:"IspNameEn"`
	DomainName     string           `position:"Query" name:"DomainName"`
	EndTime        string           `position:"Query" name:"EndTime"`
	OwnerId        requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeLiveDomainRealTimeTrafficDataResponse is the response struct for api DescribeLiveDomainRealTimeTrafficData
type DescribeLiveDomainRealTimeTrafficDataResponse struct {
	*responses.BaseResponse
	RequestId                      string                         `json:"RequestId" xml:"RequestId"`
	DomainName                     string                         `json:"DomainName" xml:"DomainName"`
	StartTime                      string                         `json:"StartTime" xml:"StartTime"`
	EndTime                        string                         `json:"EndTime" xml:"EndTime"`
	DataInterval                   string                         `json:"DataInterval" xml:"DataInterval"`
	RealTimeTrafficDataPerInterval RealTimeTrafficDataPerInterval `json:"RealTimeTrafficDataPerInterval" xml:"RealTimeTrafficDataPerInterval"`
}

// CreateDescribeLiveDomainRealTimeTrafficDataRequest creates a request to invoke DescribeLiveDomainRealTimeTrafficData API
func CreateDescribeLiveDomainRealTimeTrafficDataRequest() (request *DescribeLiveDomainRealTimeTrafficDataRequest) {
	request = &DescribeLiveDomainRealTimeTrafficDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "DescribeLiveDomainRealTimeTrafficData", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeLiveDomainRealTimeTrafficDataResponse creates a response to parse from DescribeLiveDomainRealTimeTrafficData response
func CreateDescribeLiveDomainRealTimeTrafficDataResponse() (response *DescribeLiveDomainRealTimeTrafficDataResponse) {
	response = &DescribeLiveDomainRealTimeTrafficDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
