package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EnableLiveRealtimeLogDelivery invokes the live.EnableLiveRealtimeLogDelivery API synchronously
func (client *Client) EnableLiveRealtimeLogDelivery(request *EnableLiveRealtimeLogDeliveryRequest) (response *EnableLiveRealtimeLogDeliveryResponse, err error) {
	response = CreateEnableLiveRealtimeLogDeliveryResponse()
	err = client.DoAction(request, response)
	return
}

// EnableLiveRealtimeLogDeliveryWithChan invokes the live.EnableLiveRealtimeLogDelivery API asynchronously
func (client *Client) EnableLiveRealtimeLogDeliveryWithChan(request *EnableLiveRealtimeLogDeliveryRequest) (<-chan *EnableLiveRealtimeLogDeliveryResponse, <-chan error) {
	responseChan := make(chan *EnableLiveRealtimeLogDeliveryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EnableLiveRealtimeLogDelivery(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EnableLiveRealtimeLogDeliveryWithCallback invokes the live.EnableLiveRealtimeLogDelivery API asynchronously
func (client *Client) EnableLiveRealtimeLogDeliveryWithCallback(request *EnableLiveRealtimeLogDeliveryRequest, callback func(response *EnableLiveRealtimeLogDeliveryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EnableLiveRealtimeLogDeliveryResponse
		var err error
		defer close(result)
		response, err = client.EnableLiveRealtimeLogDelivery(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EnableLiveRealtimeLogDeliveryRequest is the request struct for api EnableLiveRealtimeLogDelivery
type EnableLiveRealtimeLogDeliveryRequest struct {
	*requests.RpcRequest
	DomainName string           `position:"Query" name:"DomainName"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
}

// EnableLiveRealtimeLogDeliveryResponse is the response struct for api EnableLiveRealtimeLogDelivery
type EnableLiveRealtimeLogDeliveryResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateEnableLiveRealtimeLogDeliveryRequest creates a request to invoke EnableLiveRealtimeLogDelivery API
func CreateEnableLiveRealtimeLogDeliveryRequest() (request *EnableLiveRealtimeLogDeliveryRequest) {
	request = &EnableLiveRealtimeLogDeliveryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "EnableLiveRealtimeLogDelivery", "live", "openAPI")
	request.Method = requests.GET
	return
}

// CreateEnableLiveRealtimeLogDeliveryResponse creates a response to parse from EnableLiveRealtimeLogDelivery response
func CreateEnableLiveRealtimeLogDeliveryResponse() (response *EnableLiveRealtimeLogDeliveryResponse) {
	response = &EnableLiveRealtimeLogDeliveryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
