package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyLiveRealtimeLogDelivery invokes the live.ModifyLiveRealtimeLogDelivery API synchronously
func (client *Client) ModifyLiveRealtimeLogDelivery(request *ModifyLiveRealtimeLogDeliveryRequest) (response *ModifyLiveRealtimeLogDeliveryResponse, err error) {
	response = CreateModifyLiveRealtimeLogDeliveryResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyLiveRealtimeLogDeliveryWithChan invokes the live.ModifyLiveRealtimeLogDelivery API asynchronously
func (client *Client) ModifyLiveRealtimeLogDeliveryWithChan(request *ModifyLiveRealtimeLogDeliveryRequest) (<-chan *ModifyLiveRealtimeLogDeliveryResponse, <-chan error) {
	responseChan := make(chan *ModifyLiveRealtimeLogDeliveryResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyLiveRealtimeLogDelivery(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyLiveRealtimeLogDeliveryWithCallback invokes the live.ModifyLiveRealtimeLogDelivery API asynchronously
func (client *Client) ModifyLiveRealtimeLogDeliveryWithCallback(request *ModifyLiveRealtimeLogDeliveryRequest, callback func(response *ModifyLiveRealtimeLogDeliveryResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyLiveRealtimeLogDeliveryResponse
		var err error
		defer close(result)
		response, err = client.ModifyLiveRealtimeLogDelivery(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyLiveRealtimeLogDeliveryRequest is the request struct for api ModifyLiveRealtimeLogDelivery
type ModifyLiveRealtimeLogDeliveryRequest struct {
	*requests.RpcRequest
	Project    string           `position:"Query" name:"Project"`
	DomainName string           `position:"Query" name:"DomainName"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
	Region     string           `position:"Query" name:"Region"`
	Logstore   string           `position:"Query" name:"Logstore"`
}

// ModifyLiveRealtimeLogDeliveryResponse is the response struct for api ModifyLiveRealtimeLogDelivery
type ModifyLiveRealtimeLogDeliveryResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyLiveRealtimeLogDeliveryRequest creates a request to invoke ModifyLiveRealtimeLogDelivery API
func CreateModifyLiveRealtimeLogDeliveryRequest() (request *ModifyLiveRealtimeLogDeliveryRequest) {
	request = &ModifyLiveRealtimeLogDeliveryRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "ModifyLiveRealtimeLogDelivery", "live", "openAPI")
	request.Method = requests.GET
	return
}

// CreateModifyLiveRealtimeLogDeliveryResponse creates a response to parse from ModifyLiveRealtimeLogDelivery response
func CreateModifyLiveRealtimeLogDeliveryResponse() (response *ModifyLiveRealtimeLogDeliveryResponse) {
	response = &ModifyLiveRealtimeLogDeliveryResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
