package mts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetJobInfo invokes the mts.GetJobInfo API synchronously
func (client *Client) GetJobInfo(request *GetJobInfoRequest) (response *GetJobInfoResponse, err error) {
	response = CreateGetJobInfoResponse()
	err = client.DoAction(request, response)
	return
}

// GetJobInfoWithChan invokes the mts.GetJobInfo API asynchronously
func (client *Client) GetJobInfoWithChan(request *GetJobInfoRequest) (<-chan *GetJobInfoResponse, <-chan error) {
	responseChan := make(chan *GetJobInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetJobInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetJobInfoWithCallback invokes the mts.GetJobInfo API asynchronously
func (client *Client) GetJobInfoWithCallback(request *GetJobInfoRequest, callback func(response *GetJobInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetJobInfoResponse
		var err error
		defer close(result)
		response, err = client.GetJobInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetJobInfoRequest is the request struct for api GetJobInfo
type GetJobInfoRequest struct {
	*requests.RpcRequest
	JobId string `position:"Query" name:"jobId"`
}

// GetJobInfoResponse is the response struct for api GetJobInfo
type GetJobInfoResponse struct {
	*responses.BaseResponse
	RequestId      string         `json:"RequestId" xml:"RequestId"`
	MtsTransferJob MtsTransferJob `json:"MtsTransferJob" xml:"MtsTransferJob"`
}

// CreateGetJobInfoRequest creates a request to invoke GetJobInfo API
func CreateGetJobInfoRequest() (request *GetJobInfoRequest) {
	request = &GetJobInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Mts", "2014-06-18", "GetJobInfo", "mts", "openAPI")
	request.Method = requests.GET
	return
}

// CreateGetJobInfoResponse creates a response to parse from GetJobInfo response
func CreateGetJobInfoResponse() (response *GetJobInfoResponse) {
	response = &GetJobInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
