package mts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QuerySmarttagTemplateList invokes the mts.QuerySmarttagTemplateList API synchronously
func (client *Client) QuerySmarttagTemplateList(request *QuerySmarttagTemplateListRequest) (response *QuerySmarttagTemplateListResponse, err error) {
	response = CreateQuerySmarttagTemplateListResponse()
	err = client.DoAction(request, response)
	return
}

// QuerySmarttagTemplateListWithChan invokes the mts.QuerySmarttagTemplateList API asynchronously
func (client *Client) QuerySmarttagTemplateListWithChan(request *QuerySmarttagTemplateListRequest) (<-chan *QuerySmarttagTemplateListResponse, <-chan error) {
	responseChan := make(chan *QuerySmarttagTemplateListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QuerySmarttagTemplateList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QuerySmarttagTemplateListWithCallback invokes the mts.QuerySmarttagTemplateList API asynchronously
func (client *Client) QuerySmarttagTemplateListWithCallback(request *QuerySmarttagTemplateListRequest, callback func(response *QuerySmarttagTemplateListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QuerySmarttagTemplateListResponse
		var err error
		defer close(result)
		response, err = client.QuerySmarttagTemplateList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QuerySmarttagTemplateListRequest is the request struct for api QuerySmarttagTemplateList
type QuerySmarttagTemplateListRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	TemplateId           string           `position:"Query" name:"TemplateId"`
}

// QuerySmarttagTemplateListResponse is the response struct for api QuerySmarttagTemplateList
type QuerySmarttagTemplateListResponse struct {
	*responses.BaseResponse
	RequestId string                               `json:"RequestId" xml:"RequestId"`
	Templates TemplatesInQuerySmarttagTemplateList `json:"Templates" xml:"Templates"`
}

// CreateQuerySmarttagTemplateListRequest creates a request to invoke QuerySmarttagTemplateList API
func CreateQuerySmarttagTemplateListRequest() (request *QuerySmarttagTemplateListRequest) {
	request = &QuerySmarttagTemplateListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Mts", "2014-06-18", "QuerySmarttagTemplateList", "mts", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQuerySmarttagTemplateListResponse creates a response to parse from QuerySmarttagTemplateList response
func CreateQuerySmarttagTemplateListResponse() (response *QuerySmarttagTemplateListResponse) {
	response = &QuerySmarttagTemplateListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
