package privatelink

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateVpcEndpointConnectionAttribute invokes the privatelink.UpdateVpcEndpointConnectionAttribute API synchronously
func (client *Client) UpdateVpcEndpointConnectionAttribute(request *UpdateVpcEndpointConnectionAttributeRequest) (response *UpdateVpcEndpointConnectionAttributeResponse, err error) {
	response = CreateUpdateVpcEndpointConnectionAttributeResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateVpcEndpointConnectionAttributeWithChan invokes the privatelink.UpdateVpcEndpointConnectionAttribute API asynchronously
func (client *Client) UpdateVpcEndpointConnectionAttributeWithChan(request *UpdateVpcEndpointConnectionAttributeRequest) (<-chan *UpdateVpcEndpointConnectionAttributeResponse, <-chan error) {
	responseChan := make(chan *UpdateVpcEndpointConnectionAttributeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateVpcEndpointConnectionAttribute(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateVpcEndpointConnectionAttributeWithCallback invokes the privatelink.UpdateVpcEndpointConnectionAttribute API asynchronously
func (client *Client) UpdateVpcEndpointConnectionAttributeWithCallback(request *UpdateVpcEndpointConnectionAttributeRequest, callback func(response *UpdateVpcEndpointConnectionAttributeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateVpcEndpointConnectionAttributeResponse
		var err error
		defer close(result)
		response, err = client.UpdateVpcEndpointConnectionAttribute(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateVpcEndpointConnectionAttributeRequest is the request struct for api UpdateVpcEndpointConnectionAttribute
type UpdateVpcEndpointConnectionAttributeRequest struct {
	*requests.RpcRequest
	ClientToken string           `position:"Query" name:"ClientToken"`
	EndpointId  string           `position:"Query" name:"EndpointId"`
	DryRun      requests.Boolean `position:"Query" name:"DryRun"`
	Bandwidth   requests.Integer `position:"Query" name:"Bandwidth"`
	ServiceId   string           `position:"Query" name:"ServiceId"`
}

// UpdateVpcEndpointConnectionAttributeResponse is the response struct for api UpdateVpcEndpointConnectionAttribute
type UpdateVpcEndpointConnectionAttributeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateVpcEndpointConnectionAttributeRequest creates a request to invoke UpdateVpcEndpointConnectionAttribute API
func CreateUpdateVpcEndpointConnectionAttributeRequest() (request *UpdateVpcEndpointConnectionAttributeRequest) {
	request = &UpdateVpcEndpointConnectionAttributeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Privatelink", "2020-04-15", "UpdateVpcEndpointConnectionAttribute", "privatelink", "openAPI")
	request.Method = requests.POST
	return
}

// CreateUpdateVpcEndpointConnectionAttributeResponse creates a response to parse from UpdateVpcEndpointConnectionAttribute response
func CreateUpdateVpcEndpointConnectionAttributeResponse() (response *UpdateVpcEndpointConnectionAttributeResponse) {
	response = &UpdateVpcEndpointConnectionAttributeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
