package qualitycheck

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// InvalidRule invokes the qualitycheck.InvalidRule API synchronously
func (client *Client) InvalidRule(request *InvalidRuleRequest) (response *InvalidRuleResponse, err error) {
	response = CreateInvalidRuleResponse()
	err = client.DoAction(request, response)
	return
}

// InvalidRuleWithChan invokes the qualitycheck.InvalidRule API asynchronously
func (client *Client) InvalidRuleWithChan(request *InvalidRuleRequest) (<-chan *InvalidRuleResponse, <-chan error) {
	responseChan := make(chan *InvalidRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.InvalidRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// InvalidRuleWithCallback invokes the qualitycheck.InvalidRule API asynchronously
func (client *Client) InvalidRuleWithCallback(request *InvalidRuleRequest, callback func(response *InvalidRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *InvalidRuleResponse
		var err error
		defer close(result)
		response, err = client.InvalidRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// InvalidRuleRequest is the request struct for api InvalidRule
type InvalidRuleRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	JsonStr         string           `position:"Query" name:"JsonStr"`
}

// InvalidRuleResponse is the response struct for api InvalidRule
type InvalidRuleResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	Data      bool   `json:"Data" xml:"Data"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateInvalidRuleRequest creates a request to invoke InvalidRule API
func CreateInvalidRuleRequest() (request *InvalidRuleRequest) {
	request = &InvalidRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Qualitycheck", "2019-01-15", "InvalidRule", "", "")
	request.Method = requests.POST
	return
}

// CreateInvalidRuleResponse creates a response to parse from InvalidRule response
func CreateInvalidRuleResponse() (response *InvalidRuleResponse) {
	response = &InvalidRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
