package qualitycheck

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// TestRule invokes the qualitycheck.TestRule API synchronously
func (client *Client) TestRule(request *TestRuleRequest) (response *TestRuleResponse, err error) {
	response = CreateTestRuleResponse()
	err = client.DoAction(request, response)
	return
}

// TestRuleWithChan invokes the qualitycheck.TestRule API asynchronously
func (client *Client) TestRuleWithChan(request *TestRuleRequest) (<-chan *TestRuleResponse, <-chan error) {
	responseChan := make(chan *TestRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.TestRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// TestRuleWithCallback invokes the qualitycheck.TestRule API asynchronously
func (client *Client) TestRuleWithCallback(request *TestRuleRequest, callback func(response *TestRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *TestRuleResponse
		var err error
		defer close(result)
		response, err = client.TestRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// TestRuleRequest is the request struct for api TestRule
type TestRuleRequest struct {
	*requests.RpcRequest
	ResourceOwnerId requests.Integer `position:"Query" name:"ResourceOwnerId"`
	JsonStr         string           `position:"Query" name:"JsonStr"`
}

// TestRuleResponse is the response struct for api TestRule
type TestRuleResponse struct {
	*responses.BaseResponse
	Code      string `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateTestRuleRequest creates a request to invoke TestRule API
func CreateTestRuleRequest() (request *TestRuleRequest) {
	request = &TestRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Qualitycheck", "2019-01-15", "TestRule", "", "")
	request.Method = requests.POST
	return
}

// CreateTestRuleResponse creates a response to parse from TestRule response
func CreateTestRuleResponse() (response *TestRuleResponse) {
	response = &TestRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
