package quickbi_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetDataLevelPermissionExtraConfig invokes the quickbi_public.SetDataLevelPermissionExtraConfig API synchronously
func (client *Client) SetDataLevelPermissionExtraConfig(request *SetDataLevelPermissionExtraConfigRequest) (response *SetDataLevelPermissionExtraConfigResponse, err error) {
	response = CreateSetDataLevelPermissionExtraConfigResponse()
	err = client.DoAction(request, response)
	return
}

// SetDataLevelPermissionExtraConfigWithChan invokes the quickbi_public.SetDataLevelPermissionExtraConfig API asynchronously
func (client *Client) SetDataLevelPermissionExtraConfigWithChan(request *SetDataLevelPermissionExtraConfigRequest) (<-chan *SetDataLevelPermissionExtraConfigResponse, <-chan error) {
	responseChan := make(chan *SetDataLevelPermissionExtraConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetDataLevelPermissionExtraConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetDataLevelPermissionExtraConfigWithCallback invokes the quickbi_public.SetDataLevelPermissionExtraConfig API asynchronously
func (client *Client) SetDataLevelPermissionExtraConfigWithCallback(request *SetDataLevelPermissionExtraConfigRequest, callback func(response *SetDataLevelPermissionExtraConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetDataLevelPermissionExtraConfigResponse
		var err error
		defer close(result)
		response, err = client.SetDataLevelPermissionExtraConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetDataLevelPermissionExtraConfigRequest is the request struct for api SetDataLevelPermissionExtraConfig
type SetDataLevelPermissionExtraConfigRequest struct {
	*requests.RpcRequest
	MissHitPolicy string `position:"Query" name:"MissHitPolicy"`
	RuleType      string `position:"Query" name:"RuleType"`
	AccessPoint   string `position:"Query" name:"AccessPoint"`
	SignType      string `position:"Query" name:"SignType"`
	CubeId        string `position:"Query" name:"CubeId"`
}

// SetDataLevelPermissionExtraConfigResponse is the response struct for api SetDataLevelPermissionExtraConfig
type SetDataLevelPermissionExtraConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Result    bool   `json:"Result" xml:"Result"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateSetDataLevelPermissionExtraConfigRequest creates a request to invoke SetDataLevelPermissionExtraConfig API
func CreateSetDataLevelPermissionExtraConfigRequest() (request *SetDataLevelPermissionExtraConfigRequest) {
	request = &SetDataLevelPermissionExtraConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("quickbi-public", "2020-11-11", "SetDataLevelPermissionExtraConfig", "quickbi", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSetDataLevelPermissionExtraConfigResponse creates a response to parse from SetDataLevelPermissionExtraConfig response
func CreateSetDataLevelPermissionExtraConfigResponse() (response *SetDataLevelPermissionExtraConfigResponse) {
	response = &SetDataLevelPermissionExtraConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
