package r_kvstore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyInstanceConfig invokes the r_kvstore.ModifyInstanceConfig API synchronously
// api document: https://help.aliyun.com/api/r-kvstore/modifyinstanceconfig.html
func (client *Client) ModifyInstanceConfig(request *ModifyInstanceConfigRequest) (response *ModifyInstanceConfigResponse, err error) {
	response = CreateModifyInstanceConfigResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyInstanceConfigWithChan invokes the r_kvstore.ModifyInstanceConfig API asynchronously
// api document: https://help.aliyun.com/api/r-kvstore/modifyinstanceconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyInstanceConfigWithChan(request *ModifyInstanceConfigRequest) (<-chan *ModifyInstanceConfigResponse, <-chan error) {
	responseChan := make(chan *ModifyInstanceConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyInstanceConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyInstanceConfigWithCallback invokes the r_kvstore.ModifyInstanceConfig API asynchronously
// api document: https://help.aliyun.com/api/r-kvstore/modifyinstanceconfig.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) ModifyInstanceConfigWithCallback(request *ModifyInstanceConfigRequest, callback func(response *ModifyInstanceConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyInstanceConfigResponse
		var err error
		defer close(result)
		response, err = client.ModifyInstanceConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyInstanceConfigRequest is the request struct for api ModifyInstanceConfig
type ModifyInstanceConfigRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
	Config               string           `position:"Query" name:"Config"`
}

// ModifyInstanceConfigResponse is the response struct for api ModifyInstanceConfig
type ModifyInstanceConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyInstanceConfigRequest creates a request to invoke ModifyInstanceConfig API
func CreateModifyInstanceConfigRequest() (request *ModifyInstanceConfigRequest) {
	request = &ModifyInstanceConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("R-kvstore", "2015-01-01", "ModifyInstanceConfig", "redisa", "openAPI")
	return
}

// CreateModifyInstanceConfigResponse creates a response to parse from ModifyInstanceConfig response
func CreateModifyInstanceConfigResponse() (response *ModifyInstanceConfigResponse) {
	response = &ModifyInstanceConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
