package rdc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateProject invokes the rdc.UpdateProject API synchronously
// api document: https://help.aliyun.com/api/rdc/updateproject.html
func (client *Client) UpdateProject(request *UpdateProjectRequest) (response *UpdateProjectResponse, err error) {
	response = CreateUpdateProjectResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateProjectWithChan invokes the rdc.UpdateProject API asynchronously
// api document: https://help.aliyun.com/api/rdc/updateproject.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateProjectWithChan(request *UpdateProjectRequest) (<-chan *UpdateProjectResponse, <-chan error) {
	responseChan := make(chan *UpdateProjectResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateProject(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateProjectWithCallback invokes the rdc.UpdateProject API asynchronously
// api document: https://help.aliyun.com/api/rdc/updateproject.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) UpdateProjectWithCallback(request *UpdateProjectRequest, callback func(response *UpdateProjectResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateProjectResponse
		var err error
		defer close(result)
		response, err = client.UpdateProject(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateProjectRequest is the request struct for api UpdateProject
type UpdateProjectRequest struct {
	*requests.RpcRequest
	CorpIdentifier string `position:"Query" name:"CorpIdentifier"`
	ParamJson      string `position:"Body" name:"ParamJson"`
	StaffId        string `position:"Body" name:"StaffId"`
}

// UpdateProjectResponse is the response struct for api UpdateProject
type UpdateProjectResponse struct {
	*responses.BaseResponse
	Code      int    `json:"Code" xml:"Code"`
	Data      bool   `json:"Data" xml:"Data"`
	Success   bool   `json:"Success" xml:"Success"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateUpdateProjectRequest creates a request to invoke UpdateProject API
func CreateUpdateProjectRequest() (request *UpdateProjectRequest) {
	request = &UpdateProjectRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Rdc", "2018-08-16", "UpdateProject", "rdc", "openAPI")
	return
}

// CreateUpdateProjectResponse creates a response to parse from UpdateProject response
func CreateUpdateProjectResponse() (response *UpdateProjectResponse) {
	response = &UpdateProjectResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
