package scdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeScdnDomainRealTimeSrcTrafficData invokes the scdn.DescribeScdnDomainRealTimeSrcTrafficData API synchronously
func (client *Client) DescribeScdnDomainRealTimeSrcTrafficData(request *DescribeScdnDomainRealTimeSrcTrafficDataRequest) (response *DescribeScdnDomainRealTimeSrcTrafficDataResponse, err error) {
	response = CreateDescribeScdnDomainRealTimeSrcTrafficDataResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeScdnDomainRealTimeSrcTrafficDataWithChan invokes the scdn.DescribeScdnDomainRealTimeSrcTrafficData API asynchronously
func (client *Client) DescribeScdnDomainRealTimeSrcTrafficDataWithChan(request *DescribeScdnDomainRealTimeSrcTrafficDataRequest) (<-chan *DescribeScdnDomainRealTimeSrcTrafficDataResponse, <-chan error) {
	responseChan := make(chan *DescribeScdnDomainRealTimeSrcTrafficDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeScdnDomainRealTimeSrcTrafficData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeScdnDomainRealTimeSrcTrafficDataWithCallback invokes the scdn.DescribeScdnDomainRealTimeSrcTrafficData API asynchronously
func (client *Client) DescribeScdnDomainRealTimeSrcTrafficDataWithCallback(request *DescribeScdnDomainRealTimeSrcTrafficDataRequest, callback func(response *DescribeScdnDomainRealTimeSrcTrafficDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeScdnDomainRealTimeSrcTrafficDataResponse
		var err error
		defer close(result)
		response, err = client.DescribeScdnDomainRealTimeSrcTrafficData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeScdnDomainRealTimeSrcTrafficDataRequest is the request struct for api DescribeScdnDomainRealTimeSrcTrafficData
type DescribeScdnDomainRealTimeSrcTrafficDataRequest struct {
	*requests.RpcRequest
	StartTime  string           `position:"Query" name:"StartTime"`
	DomainName string           `position:"Query" name:"DomainName"`
	EndTime    string           `position:"Query" name:"EndTime"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeScdnDomainRealTimeSrcTrafficDataResponse is the response struct for api DescribeScdnDomainRealTimeSrcTrafficData
type DescribeScdnDomainRealTimeSrcTrafficDataResponse struct {
	*responses.BaseResponse
	RequestId                         string                            `json:"RequestId" xml:"RequestId"`
	DomainName                        string                            `json:"DomainName" xml:"DomainName"`
	StartTime                         string                            `json:"StartTime" xml:"StartTime"`
	EndTime                           string                            `json:"EndTime" xml:"EndTime"`
	DataInterval                      string                            `json:"DataInterval" xml:"DataInterval"`
	RealTimeSrcTrafficDataPerInterval RealTimeSrcTrafficDataPerInterval `json:"RealTimeSrcTrafficDataPerInterval" xml:"RealTimeSrcTrafficDataPerInterval"`
}

// CreateDescribeScdnDomainRealTimeSrcTrafficDataRequest creates a request to invoke DescribeScdnDomainRealTimeSrcTrafficData API
func CreateDescribeScdnDomainRealTimeSrcTrafficDataRequest() (request *DescribeScdnDomainRealTimeSrcTrafficDataRequest) {
	request = &DescribeScdnDomainRealTimeSrcTrafficDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("scdn", "2017-11-15", "DescribeScdnDomainRealTimeSrcTrafficData", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeScdnDomainRealTimeSrcTrafficDataResponse creates a response to parse from DescribeScdnDomainRealTimeSrcTrafficData response
func CreateDescribeScdnDomainRealTimeSrcTrafficDataResponse() (response *DescribeScdnDomainRealTimeSrcTrafficDataResponse) {
	response = &DescribeScdnDomainRealTimeSrcTrafficDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
