package trademark

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryOssResources invokes the trademark.QueryOssResources API synchronously
// api document: https://help.aliyun.com/api/trademark/queryossresources.html
func (client *Client) QueryOssResources(request *QueryOssResourcesRequest) (response *QueryOssResourcesResponse, err error) {
	response = CreateQueryOssResourcesResponse()
	err = client.DoAction(request, response)
	return
}

// QueryOssResourcesWithChan invokes the trademark.QueryOssResources API asynchronously
// api document: https://help.aliyun.com/api/trademark/queryossresources.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryOssResourcesWithChan(request *QueryOssResourcesRequest) (<-chan *QueryOssResourcesResponse, <-chan error) {
	responseChan := make(chan *QueryOssResourcesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryOssResources(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryOssResourcesWithCallback invokes the trademark.QueryOssResources API asynchronously
// api document: https://help.aliyun.com/api/trademark/queryossresources.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) QueryOssResourcesWithCallback(request *QueryOssResourcesRequest, callback func(response *QueryOssResourcesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryOssResourcesResponse
		var err error
		defer close(result)
		response, err = client.QueryOssResources(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryOssResourcesRequest is the request struct for api QueryOssResources
type QueryOssResourcesRequest struct {
	*requests.RpcRequest
	BizId string `position:"Query" name:"BizId"`
}

// QueryOssResourcesResponse is the response struct for api QueryOssResources
type QueryOssResourcesResponse struct {
	*responses.BaseResponse
	RequestId string                  `json:"RequestId" xml:"RequestId"`
	Data      DataInQueryOssResources `json:"Data" xml:"Data"`
}

// CreateQueryOssResourcesRequest creates a request to invoke QueryOssResources API
func CreateQueryOssResourcesRequest() (request *QueryOssResourcesRequest) {
	request = &QueryOssResourcesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Trademark", "2018-07-24", "QueryOssResources", "trademark", "openAPI")
	return
}

// CreateQueryOssResourcesResponse creates a response to parse from QueryOssResources response
func CreateQueryOssResourcesResponse() (response *QueryOssResourcesResponse) {
	response = &QueryOssResourcesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
