package vod

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AddVodTemplate invokes the vod.AddVodTemplate API synchronously
func (client *Client) AddVodTemplate(request *AddVodTemplateRequest) (response *AddVodTemplateResponse, err error) {
	response = CreateAddVodTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// AddVodTemplateWithChan invokes the vod.AddVodTemplate API asynchronously
func (client *Client) AddVodTemplateWithChan(request *AddVodTemplateRequest) (<-chan *AddVodTemplateResponse, <-chan error) {
	responseChan := make(chan *AddVodTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AddVodTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AddVodTemplateWithCallback invokes the vod.AddVodTemplate API asynchronously
func (client *Client) AddVodTemplateWithCallback(request *AddVodTemplateRequest, callback func(response *AddVodTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AddVodTemplateResponse
		var err error
		defer close(result)
		response, err = client.AddVodTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AddVodTemplateRequest is the request struct for api AddVodTemplate
type AddVodTemplateRequest struct {
	*requests.RpcRequest
	SubTemplateType string `position:"Query" name:"SubTemplateType"`
	TemplateConfig  string `position:"Query" name:"TemplateConfig"`
	TemplateType    string `position:"Query" name:"TemplateType"`
	AppId           string `position:"Query" name:"AppId"`
	Name            string `position:"Query" name:"Name"`
}

// AddVodTemplateResponse is the response struct for api AddVodTemplate
type AddVodTemplateResponse struct {
	*responses.BaseResponse
	RequestId     string `json:"RequestId" xml:"RequestId"`
	VodTemplateId string `json:"VodTemplateId" xml:"VodTemplateId"`
}

// CreateAddVodTemplateRequest creates a request to invoke AddVodTemplate API
func CreateAddVodTemplateRequest() (request *AddVodTemplateRequest) {
	request = &AddVodTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("vod", "2017-03-21", "AddVodTemplate", "vod", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAddVodTemplateResponse creates a response to parse from AddVodTemplate response
func CreateAddVodTemplateResponse() (response *AddVodTemplateResponse) {
	response = &AddVodTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
