package vpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DetachDhcpOptionsSetFromVpc invokes the vpc.DetachDhcpOptionsSetFromVpc API synchronously
func (client *Client) DetachDhcpOptionsSetFromVpc(request *DetachDhcpOptionsSetFromVpcRequest) (response *DetachDhcpOptionsSetFromVpcResponse, err error) {
	response = CreateDetachDhcpOptionsSetFromVpcResponse()
	err = client.DoAction(request, response)
	return
}

// DetachDhcpOptionsSetFromVpcWithChan invokes the vpc.DetachDhcpOptionsSetFromVpc API asynchronously
func (client *Client) DetachDhcpOptionsSetFromVpcWithChan(request *DetachDhcpOptionsSetFromVpcRequest) (<-chan *DetachDhcpOptionsSetFromVpcResponse, <-chan error) {
	responseChan := make(chan *DetachDhcpOptionsSetFromVpcResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DetachDhcpOptionsSetFromVpc(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DetachDhcpOptionsSetFromVpcWithCallback invokes the vpc.DetachDhcpOptionsSetFromVpc API asynchronously
func (client *Client) DetachDhcpOptionsSetFromVpcWithCallback(request *DetachDhcpOptionsSetFromVpcRequest, callback func(response *DetachDhcpOptionsSetFromVpcResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DetachDhcpOptionsSetFromVpcResponse
		var err error
		defer close(result)
		response, err = client.DetachDhcpOptionsSetFromVpc(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DetachDhcpOptionsSetFromVpcRequest is the request struct for api DetachDhcpOptionsSetFromVpc
type DetachDhcpOptionsSetFromVpcRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	DryRun               requests.Boolean `position:"Query" name:"DryRun"`
	DhcpOptionsSetId     string           `position:"Query" name:"DhcpOptionsSetId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	VpcId                string           `position:"Query" name:"VpcId"`
}

// DetachDhcpOptionsSetFromVpcResponse is the response struct for api DetachDhcpOptionsSetFromVpc
type DetachDhcpOptionsSetFromVpcResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDetachDhcpOptionsSetFromVpcRequest creates a request to invoke DetachDhcpOptionsSetFromVpc API
func CreateDetachDhcpOptionsSetFromVpcRequest() (request *DetachDhcpOptionsSetFromVpcRequest) {
	request = &DetachDhcpOptionsSetFromVpcRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Vpc", "2016-04-28", "DetachDhcpOptionsSetFromVpc", "vpc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDetachDhcpOptionsSetFromVpcResponse creates a response to parse from DetachDhcpOptionsSetFromVpc response
func CreateDetachDhcpOptionsSetFromVpcResponse() (response *DetachDhcpOptionsSetFromVpcResponse) {
	response = &DetachDhcpOptionsSetFromVpcResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
