package vs

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeVsDomainReqBpsData invokes the vs.DescribeVsDomainReqBpsData API synchronously
func (client *Client) DescribeVsDomainReqBpsData(request *DescribeVsDomainReqBpsDataRequest) (response *DescribeVsDomainReqBpsDataResponse, err error) {
	response = CreateDescribeVsDomainReqBpsDataResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeVsDomainReqBpsDataWithChan invokes the vs.DescribeVsDomainReqBpsData API asynchronously
func (client *Client) DescribeVsDomainReqBpsDataWithChan(request *DescribeVsDomainReqBpsDataRequest) (<-chan *DescribeVsDomainReqBpsDataResponse, <-chan error) {
	responseChan := make(chan *DescribeVsDomainReqBpsDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeVsDomainReqBpsData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeVsDomainReqBpsDataWithCallback invokes the vs.DescribeVsDomainReqBpsData API asynchronously
func (client *Client) DescribeVsDomainReqBpsDataWithCallback(request *DescribeVsDomainReqBpsDataRequest, callback func(response *DescribeVsDomainReqBpsDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeVsDomainReqBpsDataResponse
		var err error
		defer close(result)
		response, err = client.DescribeVsDomainReqBpsData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeVsDomainReqBpsDataRequest is the request struct for api DescribeVsDomainReqBpsData
type DescribeVsDomainReqBpsDataRequest struct {
	*requests.RpcRequest
	LocationNameEn string           `position:"Query" name:"LocationNameEn"`
	StartTime      string           `position:"Query" name:"StartTime"`
	IspNameEn      string           `position:"Query" name:"IspNameEn"`
	ShowLog        string           `position:"Query" name:"ShowLog"`
	DomainName     string           `position:"Query" name:"DomainName"`
	EndTime        string           `position:"Query" name:"EndTime"`
	OwnerId        requests.Integer `position:"Query" name:"OwnerId"`
	Interval       string           `position:"Query" name:"Interval"`
}

// DescribeVsDomainReqBpsDataResponse is the response struct for api DescribeVsDomainReqBpsData
type DescribeVsDomainReqBpsDataResponse struct {
	*responses.BaseResponse
	RequestId             string                `json:"RequestId" xml:"RequestId"`
	DomainName            string                `json:"DomainName" xml:"DomainName"`
	StartTime             string                `json:"StartTime" xml:"StartTime"`
	EndTime               string                `json:"EndTime" xml:"EndTime"`
	DataInterval          string                `json:"DataInterval" xml:"DataInterval"`
	ReqBpsDataPerInterval ReqBpsDataPerInterval `json:"ReqBpsDataPerInterval" xml:"ReqBpsDataPerInterval"`
}

// CreateDescribeVsDomainReqBpsDataRequest creates a request to invoke DescribeVsDomainReqBpsData API
func CreateDescribeVsDomainReqBpsDataRequest() (request *DescribeVsDomainReqBpsDataRequest) {
	request = &DescribeVsDomainReqBpsDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("vs", "2018-12-12", "DescribeVsDomainReqBpsData", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeVsDomainReqBpsDataResponse creates a response to parse from DescribeVsDomainReqBpsData response
func CreateDescribeVsDomainReqBpsDataResponse() (response *DescribeVsDomainReqBpsDataResponse) {
	response = &DescribeVsDomainReqBpsDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
