package waf_openapi

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDomainNames invokes the waf_openapi.DescribeDomainNames API synchronously
func (client *Client) DescribeDomainNames(request *DescribeDomainNamesRequest) (response *DescribeDomainNamesResponse, err error) {
	response = CreateDescribeDomainNamesResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDomainNamesWithChan invokes the waf_openapi.DescribeDomainNames API asynchronously
func (client *Client) DescribeDomainNamesWithChan(request *DescribeDomainNamesRequest) (<-chan *DescribeDomainNamesResponse, <-chan error) {
	responseChan := make(chan *DescribeDomainNamesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDomainNames(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDomainNamesWithCallback invokes the waf_openapi.DescribeDomainNames API asynchronously
func (client *Client) DescribeDomainNamesWithCallback(request *DescribeDomainNamesRequest, callback func(response *DescribeDomainNamesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDomainNamesResponse
		var err error
		defer close(result)
		response, err = client.DescribeDomainNames(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDomainNamesRequest is the request struct for api DescribeDomainNames
type DescribeDomainNamesRequest struct {
	*requests.RpcRequest
	ResourceGroupId string `position:"Query" name:"ResourceGroupId"`
	InstanceId      string `position:"Query" name:"InstanceId"`
	SourceIp        string `position:"Query" name:"SourceIp"`
	Lang            string `position:"Query" name:"Lang"`
	CallSource      string `position:"Query" name:"CallSource"`
}

// DescribeDomainNamesResponse is the response struct for api DescribeDomainNames
type DescribeDomainNamesResponse struct {
	*responses.BaseResponse
	RequestId   string   `json:"RequestId" xml:"RequestId"`
	DomainNames []string `json:"DomainNames" xml:"DomainNames"`
}

// CreateDescribeDomainNamesRequest creates a request to invoke DescribeDomainNames API
func CreateDescribeDomainNamesRequest() (request *DescribeDomainNamesRequest) {
	request = &DescribeDomainNamesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("waf-openapi", "2019-09-10", "DescribeDomainNames", "waf", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeDomainNamesResponse creates a response to parse from DescribeDomainNames response
func CreateDescribeDomainNamesResponse() (response *DescribeDomainNamesResponse) {
	response = &DescribeDomainNamesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
